#define _CRT_SECURE_NO_WARNINGS

#include "Loader.h"
#include "VisionUtils.h"
#include "Entity.h"
#include "GraphicsEnvironment.h"
#include "Renderer.h"
#include "Modeller.h"
#include "RenderData.h"

#include <cstring>

#include <string>
using std::string;

//---------------------------------------------------------------------------

/*VI_Mesh *VI_load_md2(const char *filename,const char *texture) {
	VI_Mesh *obj = Loader::importMD2(filename, texture);
	if( obj == NULL ) {
		return NULL;
	}
	if( !Vision::isLocked() ) {
		Object3D *d_obj = dynamic_cast<Object3D *>(obj); // cast to the internal representation
		d_obj->prepare();
	}
	return obj;
}

VI_VObject *VI_load_vobject(const char *filename) {
	VI_VObject *obj = Loader::importObject(filename);
	if( obj == NULL ) {
		return NULL;
	}
	if( !Vision::isLocked() ) {
		Object3D *d_obj = dynamic_cast<Object3D *>(obj); // cast to the internal representation
		d_obj->prepare();
	}
	return obj;
}*/

//VI_Entity *VI_load_entity_md2(VI_Object **v_obj,const char *filename,const char *texture) {
VI_Entity *Loader::importEntityMD2(VI_Mesh **v_obj,const char *filename,const char *texture) {
	*v_obj = NULL;
	VI_Mesh *obj = Loader::importMD2(filename, texture);
	if( obj == NULL ) {
		return NULL;
	}
	/*if( !Vision::isLocked() ) {
		Mesh *d_obj = dynamic_cast<Mesh *>(obj); // cast to the internal representation
		d_obj->prepare();
	}*/
	Entity *entity = new Entity(obj);
	*v_obj = obj;
	return entity;
}

/*VI_SceneGraphNode *VI_load_node_nwn(int *n_obj,VI_Object ***v_obj,const char *filename) {
	if( n_obj != NULL )
		*n_obj = NULL;
	if( v_obj != NULL )
		*v_obj = NULL;
	//ObjectData **objs = NULL;
	VI_Object **objs = NULL;
	VI_SceneGraphNode *sc = Loader::importNWN_MDL(n_obj, (v_obj==NULL) ? NULL : &objs, filename);

	if( v_obj != NULL ) {
		*v_obj = new VI_Object *[*n_obj];
		for(int i=0;i<*n_obj;i++) {
			if( !Vision::isLocked() ) {
				ObjectData *d_obj = dynamic_cast<ObjectData *>(objs[i]); // cast to the internal representation
				d_obj->prepare();
			}
			(*v_obj)[i] = objs[i];
		}
		delete [] objs;
	}
	return sc;
}*/

//

class NamedResource {
protected:
	//char *name;
	string name;
	V_CLASS_t type;
public:
	void *ptr;

	NamedResource(const char *name, V_CLASS_t type, void *ptr) {
		/*int len = strlen(name);
		this->name = new char[len+1];
		strncpy(this->name, name, len);
		this->name[len] = '\0';*/
		this->name = name;
		this->type = type;
		this->ptr = ptr;
	}
	/*~NamedResource() {
		delete [] this->name;
	}*/
	bool equals(const char *cmpname, V_CLASS_t cmptype) {
		//return ( type == cmptype && _stricmp( name.c_str(), cmpname ) == 0 );
		return ( type == cmptype && stricmp( name.c_str(), cmpname ) == 0 );
	}
};

class TDS_Material {
public:
	//char name[300];
	string name;
	Color col;
	TDS_Material * next;
};

/*struct bmp_header {
unsigned long filesize;
unsigned short reserved1,reserved2;
unsigned long imageoffset;
};

struct bmp_info {
unsigned long headersize;
unsigned long width,height;
unsigned short num_image_planes; // currently always 1
unsigned short planes; // the number of bits for each image pixel
unsigned long compression; // a code to indicate the compression type
unsigned long imagesize; // size of the image in bytes
long xm; // the number of x pixels per meter
long ym; // the number of y pixels per meter
unsigned long ncols; // the number of colors used
unsigned long icol; // the number of colors considered important
};

struct pcx_header {
unsigned char signature;
unsigned char version, code, bits_per_plane;
unsigned short xmin, ymin, xmax, ymax;
unsigned short hres, vres;
rgb_struct palette[16];
unsigned char reserved, num_planes;
unsigned short bytes_per_line;
unsigned char other_stuff[60];
};*/

/*struct wal_header {
	char name[32];		// name of the texture
	unsigned int width;	// width (in pixels) of the largest mipmap level
	unsigned int height;	// height (in pixels) of the largest mipmap level
	int offset[4];		// byte offset of the start of each of the 4 mipmap levels
	char next_name[32];	// name of the next texture in the animation
	unsigned int flags;
	unsigned int contents;
	unsigned int value;
};*/

/*struct tga_header {
//unsigned char imageIDLength;
//unsigned char colorMapType;
//unsigned char imageTypeCode;
short int colorMapOrigin;
short int colorMapLength;
short int colorMapntrySize;
short int imageXOrigin;
short int imageYOrigin;
short int imageWidth;
short int imageHeight;
unsigned char bitCount;
unsigned char imageDescription;
};*/

/*char *getFileExtension(char *filename) {
if(strlen(filename) < 4)
return NULL;
char * ext = &filename[ strlen(filename) -4 ];
if(*ext!='.')
return NULL;
ext++;
return ext;
}*/

/*void Loader::get_256_paletteBMP(FILE *the_file, rgb_struct *rgb256) {
for(int i=0;i<256;i++) {
fread(&rgb256[i].b,1,1,the_file);
fread(&rgb256[i].g,1,1,the_file);
fread(&rgb256[i].r,1,1,the_file);
fskip(the_file,1);
}
}

long Loader::get_256_palettePCX(FILE *the_file, rgb_struct *rgb256) {
fseek(the_file,0,SEEK_END);
fpos_t filelength = 0;
fgetpos(the_file,&filelength);
long palette_start = filelength - 769;
fseek(the_file, palette_start, SEEK_SET);
getc(the_file);
for(int i=0;i<256;i++) {
fread(&rgb256[i].r,1,1,the_file);
fread(&rgb256[i].g,1,1,the_file);
fread(&rgb256[i].b,1,1,the_file);
}
return palette_start;
}*/

void Loader::fskip(FILE *fp, int num_bytes) {
	for (int i=0; i<num_bytes; i++)
		fgetc(fp);
}

bool Loader::fgetLine(FILE *fp, char *ptr) {
	// returns whether eof
	for(;;) {
		if(feof(fp)) {
			*ptr=0;
			return true;
		}
		*ptr = (char)fgetc(fp);
		//if(*ptr==10 || *ptr==13 || *ptr==0) {
		if(*ptr==10 || *ptr==0) {
			*ptr=0;
			return false;
		}
		if(*ptr==13)
			*ptr=0;
		ptr++;
	}
}

char * Loader::stripWhiteSpace(char *ptr) {
	char * str = ptr;
	while(*ptr!=0) {
		if(*ptr==' ' || *ptr=='\t')
			str++;
		else
			break;
		ptr++;
	}
	return str;
}

/*void Loader::read_256BMP(FILE *pic_file,Image2D * image) {
rgb_struct rgb256[256];
get_256_paletteBMP(pic_file, rgb256);
unsigned char *data = new unsigned char [image->w * image->h];
fread(data,1,image->w * image->h,pic_file);
getRGBData(image,data,rgb256);
delete [] data;
}

void Loader::read_24bBMP(FILE *pic_file,Image2D * image) {
int image_size = image->w * image->h;
image->rgbdata = new rgb_struct[image_size];
fread(image->rgbdata,sizeof(rgb_struct),image_size,pic_file);
for(int i=0;i<image_size;i++) {
unsigned char dummy = image->rgbdata[i].r;
image->rgbdata[i].r = image->rgbdata[i].b;
image->rgbdata[i].b = dummy;
}
}

void Loader::read_256PCX(FILE *pic_file,Image2D * image) {
rgb_struct rgb256[256];
long palette_start = get_256_palettePCX(pic_file, rgb256);

//if (bmp_header.num_planes != 1) return 4;
fseek(pic_file, 128, SEEK_SET);
long total_read = 128;
unsigned char *data = new unsigned char[image->w * image->h];
unsigned char *d = data;
int DataLength = 0,buffer_size = 65536;
unsigned char * scratch = new unsigned char [buffer_size];
int c=0;
do {
DataLength = fread(scratch, 1, buffer_size, pic_file);
total_read += DataLength;
if (total_read > palette_start)
DataLength -= (total_read - palette_start);
for(unsigned char *p = scratch;p<&scratch[DataLength];) {
if( (*p & 192) == 192) {
int count = *p++ - 192;
unsigned char data = *p++;
for(int i=0;i<count;i++)
*d++ = data;
c += count;
}
else {
*d++ = *p++;
c++;
}
}
} while ((!feof(pic_file)) && (total_read < palette_start));
delete [] scratch;
getRGBData(image,data,rgb256);
delete [] data;
}*/

/*bool Loader::read_256WAL(FILE *pic_file,Image2D * image) {
	rgb_struct rgb256[256];
	FILE *lmp = NULL;
	if( fopen_s(&lmp, "q2_pal.lmp", "rb") != 0 ) {
		return false;
	}
	for(int i=0;i<256;i++) {
		fread(&rgb256[i].r,1,1,lmp);
		fread(&rgb256[i].g,1,1,lmp);
		fread(&rgb256[i].b,1,1,lmp);
	}
	fclose(lmp);
	unsigned char *data = new unsigned char[image->getWidth() * image->getHeight()];
	fread(data,1,image->getWidth() * image->getHeight(),pic_file);
	getRGBData(image,data,rgb256);
	delete [] data;
	return true;
}*/

/*void Loader::read_24bTGA(FILE *pic_file,Image2D * image,bool alpha) {
int image_size = image->w * image->h;
image->rgbdata = new rgb_struct[image_size];
for(int i=0;i<image_size;i++) {
rgb_struct rgb;
fread(&rgb,sizeof(rgb_struct),1,pic_file);
int x = i % image->w;
int y = i / image->w;
y = image->h - 1 - y;
int ni = y * image->w + x;
unsigned char dummy = rgb.r;
image->rgbdata[ni].r = rgb.b;
image->rgbdata[ni].g = rgb.g;
image->rgbdata[ni].b = dummy;
if(alpha)
fskip(pic_file,1);
}
}*/

/*void Loader::getRGBData(Image2D *image,const unsigned char *data,const rgb_struct *palette) {
	int image_size = image->getWidth() * image->getHeight();
	//image->rgbdata = new rgb_struct[image_size];
	rgb_struct *rgb = new rgb_struct[image_size];
	for(int i=0;i<image_size;i++) {
		unsigned char c = data[i];
		rgb[i] = palette[c];
	}
	image->rgbdata = (void *)rgb;
}*/

/*int Loader::loadImage2D(Image2D *image,char * filename,char *ext) {
char newfilename[300] = "";
int rtn = 0;
FILE *file = NULL;
int filetype = 0;
if(stricmp(ext,"TGA")==0)
filetype = 3;
else if(stricmp(ext,"WAL")==0)
filetype = 2;
else if(stricmp(ext,"PCX")==0)
filetype = 1;
else if(stricmp(ext,"BMP")==0)
filetype = 0;
else
return 1;
switch(filetype)
{
case 0:
{
bmp_header header;
bmp_info info;
//file = open_file(filename, "rb", &header, filetype);
file = fopen(filename, "rb");
if(file==NULL) {
sprintf(newfilename,"%s.bmp",filename);
file = fopen(newfilename, "rb");
}
if(file == NULL)
return 1;
fskip(file,2);
fread(&header, 1, sizeof(bmp_header), file);
fread(&info, 1, sizeof(bmp_info), file);
image->w = info.width;
image->h = info.height;
if(info.planes==8)
read_256BMP(file,image);
else if(info.planes==24)
read_24bBMP(file,image);
else
rtn = 1;
break;
}
case 1:
{
pcx_header header;
//file = open_file(filename, "rb", &header, filetype);
file = fopen(filename, "rb");
if(file==NULL) {
sprintf(newfilename,"%s.pcx",filename);
file = fopen(newfilename, "rb");
}
if(file == NULL)
return 1;
fread(&header, 1, sizeof(pcx_header), file);
image->w = header.xmax - header.xmin + 1;
image->h = header.ymax - header.ymin + 1;
if(header.bits_per_plane==8)
read_256PCX(file,image);
else
rtn = 1;
break;
}
case 2:
{
wal_header header;
file = fopen(filename, "rb");
if(file==NULL) {
sprintf(newfilename,"%s.wal",filename);
file = fopen(newfilename, "rb");
}
if(file == NULL)
return 1;
fread(&header, 1, sizeof(wal_header), file);
image->w = header.width;
image->h = header.height;
read_256WAL(file,image);
break;
}
case 3:
{
tga_header header;
file = fopen(filename, "rb");
if(file==NULL) {
sprintf(newfilename,"%s.tga",filename);
file = fopen(newfilename, "rb");
}
if(file == NULL)
return 1;
fskip(file,2);
fread(&header, 1, sizeof(tga_header), file);
image->w = header.imageWidth;
image->h = header.imageHeight;
if(header.bitCount==24)
read_24bTGA(file,image,false);
else if(header.bitCount==32)
read_24bTGA(file,image,true);
else
rtn = 1;
break;
}
}
fclose(file);
return rtn;
}*/

/*bool Loader::loadWAL(Image2D *image,const char * filename) {
	char newfilename[300] = "";
	FILE *file = NULL;

	wal_header header;
	if( fopen_s(&file, filename, "rb") != 0 ) {
		sprintf_s(newfilename,"%s.wal",filename);
		if( fopen_s(&file, newfilename, "rb") != 0 ) {
			return false;
		}
	}
	if(file == NULL)
		return false;
	fread(&header, 1, sizeof(wal_header), file);
	image->w = header.width;
	image->h = header.height;
	bool ok = read_256WAL(file,image);
	fclose(file);
	return ok;
}*/

/*int Loader::saveImage2DBMP(Image2D *image,char * filename) {
int rtn = 0;
int image_size = image->w * image->h;
bmp_header header;
bmp_info info;
FILE *file = fopen(filename,"wb");
if(file==NULL)
return 1;
header.filesize = sizeof(bmp_header) + 2;
header.reserved1 = 0;
header.reserved2 = 0;
header.imageoffset = sizeof(bmp_header) + sizeof(bmp_info) + 2;

info.headersize = sizeof(bmp_info);
info.num_image_planes = 1;
info.planes = 24;
info.compression = BI_RGB;
info.imagesize = image_size * 3;
info.xm = 0;
info.ym = 0;
info.icol = 0;
info.ncols = 0;
info.width = image->w;
info.height = image->h;

unsigned short ID = 0x4D42;
fwrite(&ID,1,sizeof(unsigned short),file);
fwrite(&header,1,sizeof(bmp_header),file);
fwrite(&info,1,sizeof(bmp_info),file);
unsigned char *data = new unsigned char[image_size * 3];
unsigned char *ptr = data;
for(int i=0;i<image_size;i++) {
*ptr++ = image->rgbdata[i].b;
*ptr++ = image->rgbdata[i].g;
*ptr++ = image->rgbdata[i].r;
}
fwrite(data,image_size*3,1,file);
delete [] data;

fclose(file);
return rtn;
}*/

int freadstr(char *cstr,FILE *file) {
	int bytes=0;
	for(;;) {
		*cstr = (char)fgetc(file);
		bytes++;
		if(*cstr++ == 0)
			break;
	}
	return bytes;
}

const short M3DMAGIC = 0x4D4D;
const short M3D_VERSION = 0x2;
const short COLOR_24 = 0x11;
const short MASTER_SCALE = 0x100;
const short MDATA = 0x3D3D;
const short MESH_VERSION = 0x3D3E;
const short NAMED_OBJECT = 0x4000;
const short N_TRI_OBJECT = 0x4100;
const short POINT_ARRAY = 0x4110;
const short POINT_FLAG_ARRAY = 0x4111;
const short FACE_ARRAY = 0x4120;
const short MSH_MAT_GROUP = 0x4130;
const short MAT_NAME = 0xA000;
const short MAT_DIFFUSE = 0xA020;
const short MAT_ENTRY = 0xAFFF;
const short KFDATA = 0xB000;

int Loader::parse3DSChunk(FILE * file,VI_VObject *obj,TDS_Material **first_mat,void * sub) {
	short chunk_id = 0;
	long chunk_len = 0;
	fread(&chunk_id, 1, sizeof(short), file);
	ENDIANSWAPSHORT(&chunk_id);
	if(chunk_id==0) // is this right?
		return 2;
	fread(&chunk_len, 1, sizeof(long), file);
	ENDIANSWAPLONG(&chunk_len);
	int bytes = 6;
	short tshort = 0;
	float tfloat = 0.0;
	char tcstr[1024] = "";
	int subtype = 0;
	switch(chunk_id) {
		case M3D_VERSION:
			fread(&tshort,1,sizeof(short),file);
			ENDIANSWAPSHORT(&tshort);
			bytes+=2;
			//printf("Version: %d\n",tshort);
			break;
		case COLOR_24:
			{
				if(sub==NULL) {
					LOG("Error! MAT_NAME in a chunk with null sub!\n");
					break;
				}
				TDS_Material * matsub = (TDS_Material *)sub;
				/*fread(&matsub->rgb.r,1,sizeof(char),file);
				fread(&matsub->rgb.g,1,sizeof(char),file);
				fread(&matsub->rgb.b,1,sizeof(char),file);*/
				/*rgb_struct rgb;
				fread(&rgb.r,1,sizeof(char),file);
				fread(&rgb.g,1,sizeof(char),file);
				fread(&rgb.b,1,sizeof(char),file);
				matsub->col.set(&rgb);*/
				unsigned char rgb[3];
				fread(&rgb[0],1,sizeof(char),file);
				fread(&rgb[1],1,sizeof(char),file);
				fread(&rgb[2],1,sizeof(char),file);
				matsub->col.setRGB(rgb);
				bytes+=3;
				break;
			}
		case MASTER_SCALE:
			fread(&tfloat,1,sizeof(float),file);
			ENDIANSWAPLONG(&tfloat);
			bytes+=4;
			//printf("Master Scale: %f\n",tfloat);
			break;
		case MESH_VERSION:
			fread(&tshort,1,sizeof(short),file);
			ENDIANSWAPSHORT(&tshort);
			bytes+=2;
			//printf("Mesh Version: %d\n",tshort);
			break;
		case NAMED_OBJECT:
			bytes += freadstr(tcstr,file);
			//printf("Object Name: %s\n",tcstr);
			if(sub!=NULL)
				LOG("Error! NAMED_OBJECT in a chunk with non-null sub!\n");
			//sub = new Object3D();
			sub = VI_VObject::create(tcstr);
			subtype = 1;
			break;
		case MAT_NAME:
			{
				if(sub==NULL) {
					LOG("Error! MAT_NAME in a chunk with null sub!\n");
					break;
				}
				TDS_Material * matsub = (TDS_Material *)sub;
				char name[300];
				bytes += freadstr(name,file);
				matsub->name = name;
				//printf("Material Name: %s\n",matsub->name);
				break;
			}
		case POINT_ARRAY:
			{
				if(sub==NULL) {
					LOG("Error! POINT_ARRAY in a chunk with null sub!\n");
					break;
				}
				//Object3D *d_objsub = (Object3D *)sub;
				VI_VObject *objsub = static_cast<VI_VObject *>(sub);
				//printf("Found Point Array!\n");
				fread(&tshort,1,sizeof(short),file);
				ENDIANSWAPSHORT(&tshort);
				bytes+=2;
				//printf("  Points: %d\n",tshort);
				//objsub->n_vertices = tshort;
				//objsub->set_n_vertices(tshort);
				for(int i=0;i<tshort;i++) {
					float x,y,z;
					fread(&x,1,sizeof(float),file);
					fread(&y,1,sizeof(float),file);
					fread(&z,1,sizeof(float),file);
					ENDIANSWAPLONG(&x);
					ENDIANSWAPLONG(&y);
					ENDIANSWAPLONG(&z);
					bytes+=12;
					//printf("  %f, %f, %f\n",x,y,z);
					//objsub->vertices[i] = new Vertex3D();
					// switching y and z is intentional
					/*objsub->getVertices(0)[i].x = x;
					objsub->getVertices(0)[i].y = z;
					objsub->getVertices(0)[i].z = y;*/
					//Vertex3D pos(x, z, y);
					//objsub->setVertex(0, i, &pos);
					objsub->addVertex(x, z, y);
				}
				break;
			}
		case FACE_ARRAY:
			{
				if(sub==NULL) {
					LOG("Error! POINT_ARRAY in a chunk with null sub!\n");
					break;
				}
				//Object3D *d_objsub = (Object3D *)sub;
				VI_VObject *objsub = static_cast<VI_VObject *>(sub);
				//printf("Found Face Array!\n");
				fread(&tshort,1,sizeof(short),file);
				ENDIANSWAPSHORT(&tshort);
				bytes+=2;
				//printf("  Faces: %d\n",tshort);
				//objsub->n_polys = 0;
				/*objsub->set_n_polys(0);
				objsub->expandCapacity(0,tshort); // not necessary, but saves repeated reallocations*/
				objsub->clearPolygons();
				for(int i=0;i<tshort;i++) {
					short v1,v2,v3,f;
					fread(&v1,1,sizeof(short),file);
					fread(&v2,1,sizeof(short),file);
					fread(&v3,1,sizeof(short),file);
					fread(&f,1,sizeof(short),file);
					ENDIANSWAPSHORT(&v1);
					ENDIANSWAPSHORT(&v2);
					ENDIANSWAPSHORT(&v3);
					ENDIANSWAPSHORT(&f);
					bytes+=8;
					//printf("  %d, %d, %d : %d\n",v1,v2,v3,f);
					// reverse order since we swap y and z coords around!
					objsub->addPolygon(v3,v2,v1);
					//printf("! %d %d\n",poly->vertices[0],poly->vertices[1]);
				}
				break;
			}
		case MSH_MAT_GROUP:
			{
				if(sub==NULL) {
					LOG("Error! MSH_MAT_GROUP in a chunk with null sub!\n");
					break;
				}
				//Object3D *d_objsub = (Object3D *)sub;
				VI_VObject *objsub = static_cast<VI_VObject *>(sub);
				bytes += freadstr(tcstr,file);
				//printf("(Object) Material Name: *%s*\n",tcstr);
				fread(&tshort,1,sizeof(short),file);
				ENDIANSWAPSHORT(&tshort);
				bytes+=2;
				// find the material with this name (assumes materials defined before objects!)
				TDS_Material * mat = *first_mat;
				bool found = false;
				while(mat!=NULL) {
					//printf(":*%s*\n",mat->name);
					//if(strcmp(tcstr,mat->name.c_str())==0) {
					if( mat->name == tcstr ) {
						found = true;
						objsub->setBaseColori(mat->col.getR(), mat->col.getG(), mat->col.getB());
						break;
					}
					mat = mat->next;
				}
				if(found==NULL) {
					LOG("Error! Material not found! Setting default colour of white!\n");
					//Color col;
					//col.seti(255,255,255);
					objsub->setBaseColori(255, 255, 255);
				}
				//printf("  NFaces: %d\n",tshort);
				for(int i=0;i<tshort;i++) {
					short tshort2;
					fread(&tshort2,1,sizeof(short),file);
					ENDIANSWAPSHORT(&tshort2);
					bytes+=2;
					//printf("    facenum %d : %d\n",i,tshort2);
				}
				break;
			}
		case MAT_ENTRY:
			if(sub!=NULL)
				LOG("Error! MAT_ENTRY in a chunk with non-null sub!\n");
			sub = new TDS_Material();
			subtype = 2;
			break;
		case M3DMAGIC:
		case MDATA:
		case MAT_DIFFUSE:
		case N_TRI_OBJECT:
		case KFDATA:
			// these chunks have no data, we just parse the sub chunks
			break;
		default:
			// unknown chunk, so skip this data
			fskip(file,chunk_len-6);
			return chunk_len;
	}
	// parse sub chunks
	while(bytes<chunk_len) {
		bytes+=parse3DSChunk(file,obj,first_mat,sub);
	}
	if(sub!=NULL) {
		if(subtype==1) // VI_VObject
		{
			//printf("Adding object: %d %d\n",((Object3d *)sub)->novertices,((Object3d *)sub)->nopolygons);
			//Object3D *d_objsub = (Object3D *)sub;
			VI_VObject *objsub = static_cast<VI_VObject *>(sub);
			obj->combineObject(objsub);
			delete objsub;
			//printf("New object: %d %d\n",obj->novertices,obj->nopolygons);
		}
		else if(subtype==2) // Material
		{
			((TDS_Material *)sub)->next = *first_mat;
			*first_mat = (TDS_Material *)sub;
		}
		sub=NULL; // actually has no effect
	}
	return chunk_len;
}

VI_VObject *Loader::import3DS(const char * filename) {
	LOG("Importing 3DS File: %s\n",filename);
	Vision::lock();
	FILE *file = fopen(filename, "rb");
	if( file == NULL ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open 3DS file"));
		return NULL;
	}
	/*FILE *file = NULL;
	if( fopen_s(&file, filename, "rb") != 0 ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open 3DS file"));
		return NULL;
	}*/
	//Object3D * obj = new Object3D();
	VI_VObject *obj = VI_VObject::create("Imported from Loader::import3DS");
	TDS_Material * first_mat = NULL;
	parse3DSChunk(file,obj,&first_mat,NULL);
	fclose(file);
	TDS_Material *m = first_mat;
	while(m!=NULL) {
		TDS_Material *next = m->next;
		delete m;
		m = next;
	}
	LOG("    %d vertices\n",obj->get_n_vertices());
	LOG("    %d polygons\n",obj->get_n_polys());
	Vision::unlock(false);
	if( !Vision::isLocked() ) {
		VisionObject *vo = dynamic_cast<VisionObject *>(obj);
		vo->prepare();
	}

	if( !obj->check() ) {
		Vision::setError(new VisionException(obj, VisionException::V_IMPORT_3DS_ERROR, "Imported 3DS model is corrupt"));
	}
	return obj;
}

void getFolder(char *folder,int folder_size,const char *filename) {
	const char *slash = filename;
	/*char *newslash = NULL;
	while( (newslash = strchr(slash,'\\')) !=NULL) {
	slash = newslash+2;
	}*/
	for(;;) {
		const char *next_slash = strchr(slash,'/');
		const char *next_backslash = strchr(slash,'\\');
		if( next_slash == NULL && next_backslash == NULL )
			break;
		else if( next_slash == NULL )
			slash = next_backslash+1;
		else if( next_backslash == NULL )
			slash = next_slash+1;
		else {
			slash = ( ( next_backslash < next_slash ) ? next_backslash : next_slash ) + 1;
		}
	}
	if(slash != filename) {
		//int n = (int)slash - (int)filename;
		size_t n = slash - filename;
		//strncpy_s(folder,folder_size,filename,n);
		strncpy(folder,filename,n);
		folder[n] = 0;
	}
}

#define MAX_SKINNAME 64

struct md2_stIndex_t {
	short   s;
	short   t;
};

struct md2_framePoint_t {
	unsigned char v[3]; // scaled byte to fit in frame mins/maxs
	unsigned char lightnormalindex;
};

struct md2_mesh_t {
	unsigned short index_xyz[3];
	unsigned short index_st[3];
};

struct md2_texCoord_t {
	float s;
	float t;
};

struct md2_frame_t {
	float scale[3];
	float translate[3];
	char name[16];
	md2_framePoint_t fp[1];
};

struct md2_dmdl_t {
	int                     ident;
	int                     version;
	int                     skinwidth;
	int                     skinheight;
	int                     framesize;              // byte size of each frame
	int                     num_skins;
	int                     num_xyz;
	int                     num_st;                 // greater than num_xyz for seams
	int                     num_tris;
	int                     num_glcmds;             // dwords in strip/fan command list
	int                     num_frames;
	int                     ofs_skins;              // each skin is a MAX_SKINNAME string
	int                     ofs_st;                 // byte offset from start for stverts
	int                     ofs_tris;               // offset for dtriangles
	int                     ofs_frames;             // offset for first frame
	int                     ofs_glcmds;
	int                     ofs_end;                // end of file
};

VI_VObject *Loader::importMD2(bool all,const char * filename) {
	LOG("Importing MD2 (Quake2) All %d File: %s\n",all,filename);
	Vision::lock();
	const int folder_size_c = 300;
	char folder[folder_size_c] = "";
	getFolder(folder, folder_size_c, filename);

	FILE *file = fopen(filename,"rb");
	if( file == NULL ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open MD2 file"));
		return NULL;
	}
	/*FILE *file = NULL;
	if( fopen_s(&file, filename, "rb") != 0 ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open MD2 file"));
		return NULL;
	}*/
	md2_dmdl_t header;
	//fread(&header,1,sizeof(dmdl_t),file);
	fread(&header,sizeof(md2_dmdl_t),1,file);
	if(!all)
		header.num_frames = 1;

	//Object3D *obj = new Object3D(header.num_xyz,header.num_tris,header.num_frames);
	//Object3D *obj = new Object3D(header.num_xyz,header.num_frames);
	//Object3D *obj = new Object3D(header.num_frames);
	VI_VObject *obj = VI_VObject::create("Imported from Loader::importMD2", header.num_frames);

	// textures (skins)
	//Texture **textures = NULL;
	VI_Texture **textures = NULL;
	header.num_skins = 1;
	if(header.num_skins > 0 ) {
		//textures = new Texture *[header.num_skins];
		textures = new VI_Texture *[header.num_skins];
		fseek(file,header.ofs_skins,0);
		for(int i=0;i<header.num_skins;i++) {
			char name[MAX_SKINNAME];
			fread(name,sizeof(char),MAX_SKINNAME,file);
			char *ptr = name;
			for(;;) {
				char *n = strchr(ptr,'/');
				if(n==NULL)
					n = strchr(ptr,'\\');
				if(n==NULL)
					break;
				ptr = &n[1];
			}
			char buffer[300+MAX_SKINNAME] = "";
			sprintf(buffer,"%s%s",folder,ptr);
			//textures[i] = Texture::loadTexture(buffer);
			textures[i] = GraphicsEnvironment::getSingleton()->getRenderer()->loadTexture(buffer);
			if(textures[i] == NULL) {
				Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open texture file"));
				return NULL;
			}
		}
	}
	// texture coords
	md2_stIndex_t *text_coords = NULL;
	if( header.num_st > 0 ) {
		text_coords = new md2_stIndex_t[header.num_st];
		fseek(file,header.ofs_st,0);
		fread(text_coords,sizeof(md2_stIndex_t),header.num_st,file);
	}

	// vertices
	fseek(file,header.ofs_frames,0);
	int i=0;
	//obj->set_n_vertices(header.num_xyz);
	for(i=0;i<header.num_frames;i++) {
		//Vertex3D *v = new Vertex3D();
		float scale[3];
		float translate[3];
		char name[16] = "";
		fread(scale,sizeof(float),3,file);
		fread(translate,sizeof(float),3,file);
		fread(name,sizeof(char),16,file);
		//LOG("frame %d : scale %f , %f , %f : translate %f , %f , %f\n", i, scale[0], scale[1], scale[2], translate[0], translate[1], translate[2]);
		for(int j=0;j<header.num_xyz;j++) {
			md2_framePoint_t vx;
			fread(&vx,sizeof(md2_framePoint_t),1,file);
			/*v->z = - (((float)vx.v[0]*scale[0]) + translate[0]);
			v->x = ((float)vx.v[1]*scale[1]) + translate[1];
			v->y = ((float)vx.v[2]*scale[2]) + translate[2];*/
			float z = - (((float)vx.v[0]*scale[0]) + translate[0]);
			float x = ((float)vx.v[1]*scale[1]) + translate[1];
			float y = ((float)vx.v[2]*scale[2]) + translate[2];
			//obj->setVertex(i, j, v);
			obj->addVertex(i, x, y, z);
		}
		//delete v;
	}

	// triangles
	//for(int frame=0;frame<header.num_frames;frame++) {

	fseek(file,header.ofs_tris,0);
	for(i=0;i<header.num_tris;i++) {
		md2_mesh_t tri;
		fread(&tri,sizeof(md2_mesh_t),1,file);
		/*Polygon3D poly(tri.index_xyz[0],tri.index_xyz[1],tri.index_xyz[2]);
		if(header.num_skins > 0)
			poly.setTexture(textures[0]);
		for(int j=0;j<3;j++) {
			//poly->tx[2-j] = ((float)text_coords[tri.index_st[j]].s/header.skinwidth);
			//poly->ty[2-j] = ((float)text_coords[tri.index_st[j]].t/header.skinheight);
			poly.setTextureCoords(j , ((float)text_coords[tri.index_st[j]].s/header.skinwidth), 1.0f - ((float)text_coords[tri.index_st[j]].t/header.skinheight));
			//poly->tx[j] = ((float)text_coords[tri.index_st[j]].s/header.skinwidth);
			//poly->ty[j] = 1.0f - ((float)text_coords[tri.index_st[j]].t/header.skinheight);
		}
		//if(c_texture == NULL)
		//        poly->col = c_col;
		//obj[frame]->addPolygon(poly);
		obj->addPolygon(poly);*/
		VI_Face *face = obj->addPolygon(tri.index_xyz[0],tri.index_xyz[1],tri.index_xyz[2]);
		if( header.num_skins > 0 ) {
			float u[3], v[3];
			for(int j=0;j<3;j++) {
				u[j] = ((float)text_coords[tri.index_st[j]].s/header.skinwidth);
				v[j] = 1.0f - ((float)text_coords[tri.index_st[j]].t/header.skinheight);
			}
			obj->setPolygonTextureCoords(face, textures[0], u, v);
		}
	}

	//}

	if(textures!=NULL)
		delete [] textures;
	if(text_coords!=NULL)
		delete [] text_coords;

	fclose(file);
	//obj->setShading((Polygon3D::CURVED,false);
	LOG("    %d vertices\n",obj->get_n_vertices());
	LOG("    %d polygons\n",obj->get_n_polys());
	Vision::unlock(false);
	if( !Vision::isLocked() ) {
		VisionObject *vo = dynamic_cast<VisionObject *>(obj);
		vo->prepare();
	}

	//*num_frames = header.num_frames;
	if( !obj->check() ) {
		Vision::setError(new VisionException(obj, VisionException::V_IMPORT_MD2_ERROR, "Imported MD2 model is corrupt"));
	}
	return obj;
}

const int MAX_WORDS=64;
const int MAX_LEVELS=64;
const int MAX_PROTO=64;

int Loader::getWords(const char *str,char **words) {
	int word=0;
	const char * wordstart=NULL;
	for(;;) {
		if(*str!=' ' && *str!='\t' && *str!=0 && wordstart==NULL) {
			wordstart=str;
		}
		else if((*str==' ' || *str=='\t' || *str==0) && wordstart!=NULL) {
			//int len = (int)str - (int)wordstart;
			size_t len = str - wordstart;
			words[word] = new char[len+1];
			//strncpy_s(words[word],len+1,wordstart,len);
			strncpy(words[word],wordstart,len);
			words[word][len]=0;
			//printf("%d,%d:*%s*\n",word,len,words[word]);
			word++;
			wordstart=NULL;
		}
		if(*str==NULL)
			break;
		str++;
	}
	words[word]=NULL;
	return word;
}

class RWX_VertexMap {
public:
	int vx_indx; // corresponding index in the RWX file
	bool color_set; // has a colour been set for this vertex yet?
	int col_indx;
	RWX_VertexMap(int vx_indx) {
		this->vx_indx = vx_indx;
		this->color_set = false;
		this->col_indx = -1;
	}
};

//int find_real_vertex_index(Object3D *obj,Vector *vertex_maps,Vector *uv_entries,int vx_indx,int col_indx,Color color) {
int find_real_vertex_index(VI_VObject *obj,vector<RWX_VertexMap *> *vertex_maps,vector<TextureUV *> *uv_entries,int vx_indx,int col_indx,Color color) {
	int real_vx_indx = -1;
	for(unsigned int i=0;i<vertex_maps->size() && real_vx_indx == -1;i++) {
		//RWX_VertexMap *vx_map = static_cast<RWX_VertexMap *>(vertex_maps->get(i));
		RWX_VertexMap *vx_map = vertex_maps->at(i);
		if( vx_map->vx_indx == vx_indx && ( !vx_map->color_set || vx_map->col_indx == col_indx ) ) {
			//if( vx_map->vx_indx == vx_indx ) {
			real_vx_indx = i;
			vx_map->color_set = true;
			vx_map->col_indx = col_indx;
			//Vertex3D *verts = obj->getVertices(0);
			//Vertex3D *vx = &verts[real_vx_indx];
			//vx->color.set(&color);
			/*Color *colors = obj->getColors();
			colors[real_vx_indx].set(&color);*/
			obj->setVertexColori(real_vx_indx, color.getR(), color.getG(), color.getB());
		}
	}
	//real_vx_indx = -1;
	if( real_vx_indx == -1 ) {
		RWX_VertexMap *vx_map = new RWX_VertexMap(vx_indx);
		vx_map->color_set = true;
		vx_map->col_indx = col_indx;
		//vertex_maps->add(vx_map);
		vertex_maps->push_back(vx_map);
		real_vx_indx = vertex_maps->size()-1;
		/*const Vertex3D *verts = obj->getVertices(0);
		const Vertex3D *vx = &verts[vx_indx]; // assumes that the first set of vertices are mapped 1-1*/
		//Vertex3D *n_vx = vx->copy();
		//Vertex3D n_vx = obj->getVertex(0, vx_indx); // assumes that the first set of vertices are mapped 1-1*/
		Vector3D n_vx = obj->getVertexPos(vx_indx); // assumes that the first set of vertices are mapped 1-1*/
		//n_vx->color.set(&color);
		//TextureUV *uv = static_cast<TextureUV *>(uv_entries->get(vx_indx));
		TextureUV *uv = uv_entries->at(vx_indx);
		TextureUV *n_uv = new TextureUV(uv->u,uv->v);
		//uv_entries->add(n_uv);
		uv_entries->push_back(n_uv);
		int n_vx_indx = obj->addVertex(0, n_vx.x, n_vx.y, n_vx.z);
		//obj->setVertexColor(obj->get_n_vertices()-1, color.getR(), color.getG(), color.getB());
		obj->setVertexColori(n_vx_indx, color.getR(), color.getG(), color.getB());
		/*Color *cols = obj->getColors();
		cols[obj->get_n_vertices()-1].set(&color);*/
		//obj->setColor(obj->get_n_vertices()-1, &color);
	}
	/*if( real_vx_indx == -1 ) {
	Vision::setError(new VisionException(NULL,VisionException::V_IMPORT_RWX_MDL_ERROR,"can't find real vertex index"));
	}*/
	return real_vx_indx;
}

VI_VObject *Loader::importRWX(const char * filename) {
	LOG("Importing RenderWare File: %s\n",filename);
	Vision::lock();
	const bool allowcolortex = true;

	FILE *file = fopen(filename,"rb");
	if( file == NULL ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open RWX file"));
		return NULL;
	}
	/*FILE *file = NULL;
	if( fopen_s(&file, filename, "rb") != 0 ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open RWX file"));
		return NULL;
	}*/

	const int folder_size_c = 300;
	char folder[folder_size_c] = "";
	getFolder(folder, folder_size_c, filename);

	//Object3d * obj = new Object3d();
	//Object3D * obj[MAX_LEVELS];
	//Object3D * proto[MAX_PROTO];
	VI_VObject *obj[MAX_LEVELS];
	VI_VObject *proto[MAX_PROTO];
	int cproto = 0;
	Matrix4d * mat4d[MAX_LEVELS];
	Matrix4d * jmat4d[MAX_LEVELS];
	//Vector *vertex_maps = new Vector();
	vector<RWX_VertexMap *> *vertex_maps = new vector<RWX_VertexMap *>();
	int vx_index = 0;
	int col_index = 0;
	//Vector *uv_entries = new Vector();
	vector<TextureUV *> *uv_entries = new vector<TextureUV *>();
	//int i=0;
	for(int i=0;i<MAX_LEVELS;i++) {
		obj[i]=NULL;
		mat4d[i]=NULL;
		jmat4d[i]=NULL;
	}
	//Vector *resources = new Vector();
	vector<NamedResource *> *resources = new vector<NamedResource *>();
	int cobj=-1;
	int cmat4d=-1;
	int cjmat4d=-1;

	mat4d[++cmat4d] = Matrix4d::createIdentity();
	jmat4d[++cjmat4d] = Matrix4d::createIdentity();

	//rgb_struct c_rgb = {255,255,255};
	//Color c_col(1.0f,1.0f,1.0f);
	Color c_col;
	c_col.seti(255,255,255);
	VI_Texture *c_texture = NULL;
	char buffer[1024];
	char *str;
	char *words[MAX_WORDS];
	for(;;) {
		if(fgetLine(file,buffer))
			break;
		/*if( strstr(buffer, "11597") != NULL )
		printf("!\n");*/
		//printf("->:%s\n",buffer);
		str = stripWhiteSpace(buffer);
		//printf("->:%s\n",str);
		int n_words = getWords(str,words);
		if(n_words == 0)
			continue;
		if(*words[0]=='#')
		{
		}
		//else if(_stricmp(words[0],"ModelBegin")==0)
		else if(stricmp(words[0],"ModelBegin")==0)
		{
			if(cobj!=-1)
				LOG("Error - ModelBegin must be first statement!\n");
			else {
				//obj[++cobj] = new Object3D();
				obj[++cobj] = VI_VObject::create("ModelBegin RWX object");
				vx_index = 0;
				col_index = 0;
				for(unsigned int i=0;i<uv_entries->size();i++) {
					//delete static_cast<TextureUV *>(uv_entries->get(i));
					delete uv_entries->at(i);
				}
				//uv_entries->removeAll();
				uv_entries->clear();
				for(unsigned int i=0;i<vertex_maps->size();i++) {
					//delete static_cast<RWX_VertexMap *>(vertex_maps->get(i));
					delete vertex_maps->at(i);
				}
				//vertex_maps->removeAll();
				vertex_maps->clear();
			}
		}
		//else if(_stricmp(words[0],"ModelEnd")==0)
		else if(stricmp(words[0],"ModelEnd")==0)
		{
			if(cobj!=0)
				LOG("Error - ModelEnd must be last statement!\n");
			else {
				cobj--;
			}
		}
		//else if(_stricmp(words[0],"ClumpBegin")==0)
		else if(stricmp(words[0],"ClumpBegin")==0)
		{
			//obj[++cobj] = new Object3D();
			obj[++cobj] = VI_VObject::create("ClumpBegin RWX Object");
			vx_index = 0;
			col_index = 0;
			for(unsigned int i=0;i<uv_entries->size();i++) {
				//delete static_cast<TextureUV *>(uv_entries->get(i));
				delete uv_entries->at(i);
			}
			//uv_entries->removeAll();
			uv_entries->clear();
			for(unsigned int i=0;i<vertex_maps->size();i++) {
				//delete static_cast<RWX_VertexMap *>(vertex_maps->get(i));
				delete vertex_maps->at(i);
			}
			//vertex_maps->removeAll();
			vertex_maps->clear();
			mat4d[++cmat4d] = Matrix4d::createIdentity();
			jmat4d[++cjmat4d] = Matrix4d::createIdentity();
			//printf("Now on: %d\n",cobj);
		}
		//else if(_stricmp(words[0],"ClumpEnd")==0)
		else if(stricmp(words[0],"ClumpEnd")==0)
		{
			if(cobj<1)
				LOG("No ModelBegin and/or ClumpBegin statement!\n");
			else {
				// joint
				delete jmat4d[cjmat4d];
				jmat4d[cjmat4d--]=NULL;
				obj[cobj]->transform4d(jmat4d[cjmat4d]);
				// ctm
				delete mat4d[cmat4d];
				mat4d[cmat4d--]=NULL;
				obj[cobj]->transform4d(mat4d[cmat4d]);
				obj[cobj-1]->combineObject(obj[cobj]);
				delete obj[cobj];
				obj[cobj--]=NULL;
				//printf("Now on: %d\n",cobj);
			}
		}
		//else if(_stricmp(words[0],"ProtoBegin")==0)
		else if(stricmp(words[0],"ProtoBegin")==0)
		{
			//obj[++cobj] = new Object3D();
			obj[++cobj] = VI_VObject::create(words[1]);
			vx_index = 0;
			col_index = 0;
			for(unsigned int i=0;i<uv_entries->size();i++) {
				//delete static_cast<TextureUV *>(uv_entries->get(i));
				delete uv_entries->at(i);
			}
			//uv_entries->removeAll();
			uv_entries->clear();
			for(unsigned int i=0;i<vertex_maps->size();i++) {
				//delete static_cast<RWX_VertexMap *>(vertex_maps->get(i));
				delete vertex_maps->at(i);
			}
			//vertex_maps->removeAll();
			vertex_maps->clear();
			//strcpy(obj[cobj]->name,words[1]);
			//obj[cobj]->setName(words[1]);
			mat4d[++cmat4d] = Matrix4d::createIdentity(); // ?
			jmat4d[++cjmat4d] = Matrix4d::createIdentity(); // ?
			//printf("Proto now on: %d\n",cobj);
		}
		//else if(_stricmp(words[0],"ProtoEnd")==0)
		else if(stricmp(words[0],"ProtoEnd")==0)
		{
			if(cobj<0)
				LOG("No ProtoBegin statement!\n");
			else {
				proto[cproto++] = obj[cobj];
				obj[cobj--]=NULL;
				delete jmat4d[cjmat4d]; // ?
				jmat4d[cjmat4d--]=NULL; // ?
				delete mat4d[cmat4d]; // ?
				mat4d[cmat4d--]=NULL; // ?
				//printf("Proto Now on: %d\n",cproto);
			}
		}
		//else if(_stricmp(words[0],"TransformBegin")==0)
		else if(stricmp(words[0],"TransformBegin")==0)
		{
			//mat4d[++cmat4d] = new Matrix4d();
			//*mat4d[cmat4d] = *mat4d[cmat4d-1];
			mat4d[++cmat4d] = Matrix4d::createIdentity();
			//printf("*** %d : %d\n",cmat4d,mat4d[cmat4d]);
		}
		//else if(_stricmp(words[0],"TransformEnd")==0)
		else if(stricmp(words[0],"TransformEnd")==0)
		{
			if(cmat4d<1)
				LOG("No TransformBegin statement!\n");
			else {
				delete mat4d[cmat4d];
				mat4d[cmat4d--]=NULL;
			}
		}
		//else if(_stricmp(words[0],"Transform")==0)
		else if(stricmp(words[0],"Transform")==0)
		{
			int w = 1;
			//Matrix4d * nm = new Matrix4d();
			for(int i=0;i<4;i++) { // row
				for(int j=0;j<4;j++) { // column
					float n;
					sscanf(words[w++],"%f",&n);
					//nm->m[i][j] = n;
					//mat4d[cmat4d]->m[i][j] = n;
					mat4d[cmat4d]->setElement(j,i,n);
				}
			}
			//printf("*** %d : %d\n",cmat4d,mat4d[cmat4d]);
		}
		//else if(_stricmp(words[0],"Identity")==0)
		else if(stricmp(words[0],"Identity")==0)
		{
			mat4d[cmat4d]->setIdentity();
		}
		//else if(_stricmp(words[0],"Scale")==0)
		else if(stricmp(words[0],"Scale")==0)
		{
			float x,y,z;
			sscanf(words[1],"%f",&x);
			sscanf(words[2],"%f",&y);
			sscanf(words[3],"%f",&z);
			Matrix4d * trans = Matrix4d::createScale(x,y,z);
			Matrix4d *out = mat4d[cmat4d]->multiply(trans);
			//Matrix4d *out = trans->multiply(mat4d[cmat4d]);
			delete mat4d[cmat4d];
			delete trans;
			mat4d[cmat4d] = out;
		}
		//else if(_stricmp(words[0],"Rotate")==0)
		else if(stricmp(words[0],"Rotate")==0)
		{
			float x,y,z,a;
			sscanf(words[1],"%f",&x);
			sscanf(words[2],"%f",&y);
			sscanf(words[3],"%f",&z);
			sscanf(words[4],"%f",&a);
			Matrix4d * trans = Matrix4d::createRotation(x,y,z,a);
			Matrix4d *out = mat4d[cmat4d]->multiply(trans);
			//Matrix4d *out = trans->multiply(mat4d[cmat4d]);
			delete mat4d[cmat4d];
			delete trans;
			mat4d[cmat4d] = out;
		}
		//else if(_stricmp(words[0],"Rotate")==0)
		else if(stricmp(words[0],"Rotate")==0)
		{
			float x,y,z;
			sscanf(words[1],"%f",&x);
			sscanf(words[2],"%f",&y);
			sscanf(words[3],"%f",&z);
			Matrix4d *trans = Matrix4d::createTranslation(x,y,z);
			Matrix4d *out = mat4d[cmat4d]->multiply(trans);
			//Matrix4d *out = trans->multiply(mat4d[cmat4d]);
			delete mat4d[cmat4d];
			delete trans;
			mat4d[cmat4d] = out;
		}
		//else if(_stricmp(words[0],"JointTransformBegin")==0)
		else if(stricmp(words[0],"JointTransformBegin")==0)
		{
			//jmat4d[++cjmat4d] = Matrix4d::createIdentity();
			jmat4d[++cjmat4d] = new Matrix4d();
			*jmat4d[cjmat4d] = *jmat4d[cjmat4d-1];
		}
		//else if(_stricmp(words[0],"JointTransformEnd")==0)
		else if(stricmp(words[0],"JointTransformEnd")==0)
		{
			if(cjmat4d<1)
				LOG("No JointTransformBegin statement!\n");
			else {
				delete jmat4d[cjmat4d];
				jmat4d[cjmat4d--]=NULL;
			}
		}
		//else if(_stricmp(words[0],"TransformJoint")==0)
		else if(stricmp(words[0],"TransformJoint")==0)
		{
			int w = 1;
			for(int i=0;i<4;i++) { // row
				for(int j=0;j<4;j++) { // column
					float n;
					sscanf(words[w++],"%f",&n);
					//jmat4d[cjmat4d]->m[i][j] = n;
					jmat4d[cmat4d]->setElement(j,i,n);
				}
			}
		}
		//else if(_stricmp(words[0],"IdentityJoint")==0)
		else if(stricmp(words[0],"IdentityJoint")==0)
		{
			jmat4d[cjmat4d]->setIdentity();
		}
		//else if(_stricmp(words[0],"RotateJoint")==0)
		else if(stricmp(words[0],"RotateJoint")==0)
		{
			float x,y,z,a;
			sscanf(words[1],"%f",&x);
			sscanf(words[2],"%f",&y);
			sscanf(words[3],"%f",&z);
			sscanf(words[4],"%f",&a);
			Matrix4d * trans = Matrix4d::createRotation(x,y,z,a);
			Matrix4d *out = jmat4d[cjmat4d]->multiply(trans);
			delete jmat4d[cjmat4d];
			delete trans;
			jmat4d[cjmat4d] = out;
		}
		//else if(_stricmp(words[0],"Color")==0)
		else if(stricmp(words[0],"Color")==0)
		{
			float r,g,b;
			sscanf(words[1],"%f",&r);
			sscanf(words[2],"%f",&g);
			sscanf(words[3],"%f",&b);
			/*c_col.R = r;
			c_col.G = g;
			c_col.B = b;*/
			c_col.setf(r,g,b);
			//printf("Found Color!: %d,%d,%d\n",c_rgb.r,c_rgb.g,c_rgb.b);
			col_index++;
		}
		//else if(_stricmp(words[0],"Texture")==0)
		else if(stricmp(words[0],"Texture")==0)
		{
			//if(_stricmp(words[1],"NULL")==0) {
			if(stricmp(words[1],"NULL")==0) {
				c_texture = NULL;
			}
			else {
				char buffer[1024] = "";
				/*
				bool bmp = false;
				sprintf(buffer,"%s%s.pcx",folder,words[1]);

				#ifdef _WIN32
				if(!FileExists(buffer))
				sprintf(buffer,"textures/%s.pcx",words[1]);
				if(!FileExists(buffer))
				sprintf(buffer,"%s.pcx",words[1]);

				if(!FileExists(buffer)) {
				sprintf(buffer,"%s%s.bmp",folder,words[1]);
				bmp = true;
				}
				if(!FileExists(buffer))
				sprintf(buffer,"textures/%s.bmp",words[1]);
				if(!FileExists(buffer))
				sprintf(buffer,"%s.bmp",words[1]);
				#endif*/

				/*if(bmp)
				c_texture = new Texture(buffer,"bmp");
				else
				c_texture = new Texture(buffer,"pcx");*/
				/*if(bmp)
				c_texture = Texture::loadTexture(buffer,"bmp");
				else
				c_texture = Texture::loadTexture(buffer,"pcx");*/

				c_texture = NULL;
				for(unsigned int i=0;i<resources->size() && c_texture == NULL;i++) {
					//NamedResource *resource = static_cast<NamedResource *>(resources->get(i));
					NamedResource *resource = resources->at(i);
					if( resource->equals( words[1], V_CLASS_TEXTURE ) ) {
						c_texture = (VI_Texture *)resource->ptr;
					}
				}

				if( c_texture == NULL ) {
					sprintf(buffer,"%s%s",folder,words[1]);
					//c_texture = Texture::loadTexture(buffer);
					try {
						c_texture = GraphicsEnvironment::getSingleton()->getRenderer()->loadTexture(buffer);
					}
					catch(VisionException *ve) {
						if( ve->type == VisionException::V_FILE_ERROR ) {
							if(c_texture == NULL) {
								LOG("WARNING - cannot load %s\n",buffer);
							}
							delete ve;
						}
						else {
							throw ve;
						}
					}

					if( c_texture == NULL ) {
						sprintf(buffer,"%s%s.jpg",folder,words[1]);
						try {
							c_texture = GraphicsEnvironment::getSingleton()->getRenderer()->loadTexture(buffer);
						}
						catch(VisionException *ve) {
							if( ve->type == VisionException::V_FILE_ERROR ) {
								if(c_texture == NULL) {
									LOG("WARNING - cannot load %s\n",buffer);
								}
								delete ve;
							}
							else {
								throw ve;
							}
						}
					}

					if(c_texture == NULL) {
						Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open texture file"));
						return NULL;
					}

					NamedResource *resource = new NamedResource(words[1], V_CLASS_TEXTURE, c_texture);
					//resources->add(resource);
					resources->push_back(resource);
				}
			}
		}
		//else if(_stricmp(words[0],"Vertex")==0 || _stricmp(words[0],"VertexExt")==0)
		else if(stricmp(words[0],"Vertex")==0 || stricmp(words[0],"VertexExt")==0)
		{
			float x,y,z;
			sscanf(words[1],"%f",&x);
			sscanf(words[2],"%f",&y);
			sscanf(words[3],"%f",&z);
			//Vertex3D v(x, y, z);
			Vector3D v(x, y, z);
			//printf("Found Vertex!: %f,%f,%f\n",x,y,z);
			//printf("  : %d,%d,%d\n",v->x,v->y,v->z);
			//printf("*** %d : %d\n",cmat4d,mat4d[cmat4d]);
			mat4d[cmat4d]->transformVector(&v);
			//printf("  : %d,%d,%d\n",v->x,v->y,v->z);
			TextureUV *uv = NULL;
			//if(_stricmp(words[0],"VertexExt")==0) {
			if(stricmp(words[0],"VertexExt")==0) {
				int w = -1;
				//if(_stricmp(words[4],"UV")==0)
				if(stricmp(words[4],"UV")==0)
					w=4;
				//else if(_stricmp(words[8],"UV")==0)
				else if(stricmp(words[8],"UV")==0)
					w=8;
				if(w != -1) {
					float tx_u = -1,tx_v = -1;
					//sscanf(words[w+1],"%f",&v->u);
					//sscanf(words[w+2],"%f",&v->v);
					sscanf(words[w+1],"%f",&tx_u);
					sscanf(words[w+2],"%f",&tx_v);
					uv = new TextureUV(tx_u,tx_v);
				}
			}
			if( uv == NULL )
				uv = new TextureUV(-1,-1);
			//uv_entries->add(uv);
			uv_entries->push_back(uv);
			RWX_VertexMap *vx_map = new RWX_VertexMap(vx_index++);
			//vertex_maps->add(vx_map);
			vertex_maps->push_back(vx_map);
			obj[cobj]->addVertex(0, v.x, v.y, v.z);
		}
		//else if(_stricmp(words[0],"Quad")==0 || _stricmp(words[0],"QuadExt")==0)
		else if(stricmp(words[0],"Quad")==0 || stricmp(words[0],"QuadExt")==0)
		{
			int v1,v2,v3,v4;
			sscanf(words[1],"%d",&v1);
			sscanf(words[2],"%d",&v2);
			sscanf(words[3],"%d",&v3);
			sscanf(words[4],"%d",&v4);
			// must -1 from all vertices!
			v1--; v2--; v3--; v4--;
			int r_v1 = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v1, col_index, c_col);
			int r_v2 = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v2, col_index, c_col);
			int r_v3 = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v3, col_index, c_col);
			int r_v4 = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v4, col_index, c_col);
			/*Polygon3D poly(r_v1,r_v2,r_v3,r_v4);
			if(c_texture!=NULL) {
				//poly->setTextureWrap(obj[cobj]->getVertices(0),(TextureUV **)uv_entries->getData(),c_texture);
				//poly->setTextureWrap(obj[cobj]->getVertices(0),&*uv_entries->begin(),c_texture);
				poly.setTextureWrap(c_texture, &*uv_entries->begin());
			}
			//if(c_texture == NULL || allowcolortex)
			//poly->col = c_col;
			obj[cobj]->addPolygon(poly);*/
			VI_Face *face = obj[cobj]->addPolygon(r_v1,r_v2,r_v3,r_v4);
			if( c_texture != NULL ) {
				obj[cobj]->setPolygonTextureWrap(face, c_texture, &*uv_entries->begin());
			}
		}
		//else if(_stricmp(words[0],"Triangle")==0 || _stricmp(words[0],"TriangleExt")==0)
		else if(stricmp(words[0],"Triangle")==0 || stricmp(words[0],"TriangleExt")==0)
		{
			int v1,v2,v3;
			sscanf(words[1],"%d",&v1);
			sscanf(words[2],"%d",&v2);
			sscanf(words[3],"%d",&v3);
			// must -1 from all vertices!
			v1--; v2--; v3--;
			int r_v1 = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v1, col_index, c_col);
			int r_v2 = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v2, col_index, c_col);
			int r_v3 = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v3, col_index, c_col);
			/*Polygon3D poly(r_v1,r_v2,r_v3);
			if(c_texture!=NULL) {
				//poly->setTextureWrap(obj[cobj]->getVertices(0),(TextureUV **)uv_entries->getData(),c_texture);
				//poly->setTextureWrap(obj[cobj]->getVertices(0),&*uv_entries->begin(),c_texture);
				poly.setTextureWrap(c_texture, &*uv_entries->begin());
			}
			//if(c_texture == NULL || allowcolortex)
			//poly->col = c_col;
			obj[cobj]->addPolygon(poly);*/
			VI_Face *face = obj[cobj]->addPolygon(r_v1,r_v2,r_v3);
			if( c_texture != NULL ) {
				obj[cobj]->setPolygonTextureWrap(face, c_texture, &*uv_entries->begin());
			}
		}
		//else if(_stricmp(words[0],"Polygon")==0 || _stricmp(words[0],"PolygonExt")==0)
		else if(stricmp(words[0],"Polygon")==0 || stricmp(words[0],"PolygonExt")==0)
		{
			int nv=0,v=0;
			sscanf(words[1],"%d",&nv);
			/*Polygon3D poly;
			if(c_texture!=NULL) {
				//poly->setTextureWrap(obj[cobj]->getVertices(0),(TextureUV **)uv_entries->getData(),c_texture);
				//poly->setTextureWrap(obj[cobj]->getVertices(0),&*uv_entries->begin(),c_texture);
				poly.setTextureWrap(c_texture, &*uv_entries->begin());
			}
			//if(c_texture == NULL || allowcolortex)
			//poly->col = c_col;
			poly.setNVertices(nv);
			for(int i=0;i<nv;i++) {
				sscanf(words[i+2],"%d",&v);
				v--;
				int r_v = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v, col_index, c_col);
				poly.setVertex(i, r_v);
			}
			obj[cobj]->addPolygon(poly);*/
			int *vlist = new int[nv];
			for(int i=0;i<nv;i++) {
				sscanf(words[i+2],"%d",&v);
				v--;
				int r_v = find_real_vertex_index(obj[cobj], vertex_maps, uv_entries, v, col_index, c_col);
				vlist[i] = r_v;
			}
			VI_Face *face = obj[cobj]->addPolygon(vlist, nv, "");
			delete [] vlist;
			if( c_texture != NULL ) {
				obj[cobj]->setPolygonTextureWrap(face, c_texture, &*uv_entries->begin());
			}
		}
		//else if(_stricmp(words[0],"Cone")==0)
		else if(stricmp(words[0],"Cone")==0)
		{
			float h,r;
			int n;
			sscanf(words[1],"%f",&h);
			sscanf(words[2],"%f",&r);
			sscanf(words[3],"%d",&n);
			VI_VObject * nobj = VI_Modeller::createCone(h,r,n);
			nobj->transform4d(mat4d[cmat4d]);
			//Object3D *d_nobj = dynamic_cast<Object3D *>(nobj); // cast to the internal representation
			if(c_texture!=NULL) {
				//nobj->setTextureWrap(c_texture,(TextureUV **)uv_entries->getData(),false);
				nobj->setTextureWrap(c_texture,&*uv_entries->begin());
			}
			if(c_texture == NULL || allowcolortex)
				nobj->setBaseColori(c_col.getR(), c_col.getG(), c_col.getB());
			obj[cobj]->combineObject(nobj);
			delete nobj;
		}
		//else if(_stricmp(words[0],"Disc")==0)
		else if(stricmp(words[0],"Disc")==0)
		{
			float h,r;
			int n;
			sscanf(words[1],"%f",&h);
			sscanf(words[2],"%f",&r);
			sscanf(words[3],"%d",&n);
			VI_VObject * nobj = VI_Modeller::createDisc(h,r,n,true);
			nobj->transform4d(mat4d[cmat4d]);
			//Object3D *d_nobj = dynamic_cast<Object3D *>(nobj); // cast to the internal representation
			if(c_texture!=NULL) {
				//nobj->setTextureWrap(c_texture,(TextureUV **)uv_entries->getData(),false);
				nobj->setTextureWrap(c_texture,&*uv_entries->begin());
			}
			if(c_texture == NULL || allowcolortex)
				nobj->setBaseColori(c_col.getR(), c_col.getG(), c_col.getB());
			obj[cobj]->combineObject(nobj);
			delete nobj;
		}
		//else if(_stricmp(words[0],"Sphere")==0)
		else if(stricmp(words[0],"Sphere")==0)
		{
			float r;
			int d;
			sscanf(words[1],"%f",&r);
			sscanf(words[2],"%d",&d);
			VI_VObject * nobj = VI_Modeller::createSphere(r,d);
			nobj->transform4d(mat4d[cmat4d]);
			//Object3D *d_nobj = dynamic_cast<Object3D *>(nobj); // cast to the internal representation
			if(c_texture!=NULL) {
				//nobj->setTextureWrap(c_texture,(TextureUV **)uv_entries->getData(),false);
				nobj->setTextureWrap(c_texture,&*uv_entries->begin());
			}
			if(c_texture == NULL || allowcolortex)
				nobj->setBaseColori(c_col.getR(), c_col.getGf(), c_col.getB());
			obj[cobj]->combineObject(nobj);
			delete nobj;
		}
		//else if(_stricmp(words[0],"Hemisphere")==0)
		else if(stricmp(words[0],"Hemisphere")==0)
		{
			float r;
			int d;
			sscanf(words[1],"%f",&r);
			sscanf(words[2],"%d",&d);
			VI_VObject * nobj = VI_Modeller::createHemisphere(r,d);
			nobj->transform4d(mat4d[cmat4d]);
			//Object3D *d_nobj = dynamic_cast<Object3D *>(nobj); // cast to the internal representation
			if(c_texture!=NULL) {
				//nobj->setTextureWrap(c_texture,(TextureUV **)uv_entries->getData(),false);
				nobj->setTextureWrap(c_texture,&*uv_entries->begin());
			}
			if(c_texture == NULL || allowcolortex)
				nobj->setBaseColori(c_col.getR(), c_col.getG(), c_col.getB());
			obj[cobj]->combineObject(nobj);
			delete nobj;
		}
		//else if(_stricmp(words[0],"Cylinder")==0)
		else if(stricmp(words[0],"Cylinder")==0)
		{
			float h,r1,r2;
			int n;
			sscanf(words[1],"%f",&h);
			sscanf(words[2],"%f",&r1);
			sscanf(words[3],"%f",&r2);
			sscanf(words[4],"%d",&n);
			VI_VObject * nobj = VI_Modeller::createCylinder(h,r1,r2,n);
			nobj->transform4d(mat4d[cmat4d]);
			//Object3D *d_nobj = dynamic_cast<Object3D *>(nobj); // cast to the internal representation
			if(c_texture!=NULL) {
				//nobj->setTextureWrap(c_texture,(TextureUV **)uv_entries->getData(),false);
				nobj->setTextureWrap(c_texture,&*uv_entries->begin());
			}
			if(c_texture == NULL || allowcolortex)
				nobj->setBaseColori(c_col.getR(), c_col.getG(), c_col.getB());
			obj[cobj]->combineObject(nobj);
			delete nobj;
		}
		//else if(_stricmp(words[0],"Block")==0)
		else if(stricmp(words[0],"Block")==0)
		{
			float w,h,d;
			sscanf(words[1],"%f",&w);
			sscanf(words[2],"%f",&h);
			sscanf(words[3],"%f",&d);
			VI_VObject * nobj = VI_Modeller::createCuboid(w,h,d);
			nobj->transform4d(mat4d[cmat4d]);
			//Object3D *d_nobj = dynamic_cast<Object3D *>(nobj); // cast to the internal representation
			if(c_texture!=NULL) {
				//nobj->setTextureWrap(c_texture,(TextureUV **)uv_entries->getData(),false);
				nobj->setTextureWrap(c_texture,&*uv_entries->begin());
			}
			if(c_texture == NULL || allowcolortex)
				nobj->setBaseColori(c_col.getR(), c_col.getG(), c_col.getB());
			obj[cobj]->combineObject(nobj);
			delete nobj;
		}
		//else if(_stricmp(words[0],"ProtoInstance")==0)
		else if(stricmp(words[0],"ProtoInstance")==0)
		{
			for(int i=0;i<cproto;i++) {
				VisionObject *d_proto = dynamic_cast<VisionObject *>(proto[i]); // cast to the internal representation
				//if(_stricmp(d_proto->getName(),words[1])==0) {
				if(stricmp(d_proto->getName(),words[1])==0) {
					VI_VObject *nobj = proto[i]->clone();
					nobj->transform4d(mat4d[cmat4d]);
					//nobj->setBaseColour(c_rgb);
					//delete proto[i];
					//printf("");
					obj[cobj]->combineObject(nobj);
					break;
				}
			}
		}
		//else if(_stricmp(words[0],"ProtoInstanceGeometry")==0)
		else if(stricmp(words[0],"ProtoInstanceGeometry")==0)
		{
			for(int i=0;i<cproto;i++) {
				VisionObject *d_proto = dynamic_cast<VisionObject *>(proto[i]); // cast to the internal representation
				//if(_stricmp(d_proto->getName(),words[1])==0) {
				if(stricmp(d_proto->getName(),words[1])==0) {
					VI_VObject *nobj = proto[i]->clone();
					nobj->transform4d(mat4d[cmat4d]);
					//Object3D *d_nobj = dynamic_cast<Object3D *>(nobj); // cast to the internal representation
					//nobj->setTexture(c_texture);
					if(c_texture!=NULL) {
						//nobj->setTextureWrap(c_texture,(TextureUV **)uv_entries->getData(),false);
						nobj->setTextureWrap(c_texture,&*uv_entries->begin());
					}
					if(c_texture == NULL || allowcolortex)
						nobj->setBaseColori(c_col.getR(), c_col.getG(), c_col.getB());
					else {
						nobj->setBaseColori(255, 255, 255);
					}
					obj[cobj]->combineObject(nobj);
					break;
				}
			}
		}
		else
			LOG("Unknown Command : %s\n",words[0]);
		for(int i=0;i<n_words;i++) {
			delete words[i];
			words[i]=NULL;
		}
	}
	fclose(file);
	for(int i=0;i<cproto;i++) {
		delete proto[i];
	}
	delete mat4d[cmat4d];
	delete jmat4d[cjmat4d];
	for(unsigned int i=0;i<uv_entries->size();i++) {
		//delete static_cast<TextureUV *>(uv_entries->get(i));
		delete uv_entries->at(i);
	}
	delete uv_entries;
	for(unsigned int i=0;i<vertex_maps->size();i++) {
		//delete static_cast<RWX_VertexMap *>(vertex_maps->get(i));
		delete vertex_maps->at(i);
	}
	delete vertex_maps;
	for(unsigned int i=0;i<resources->size();i++) {
		/*NamedResource *resource = static_cast<NamedResource *>(resources->get(i));
		delete resource;*/
		delete resources->at(i);
	}
	delete resources;
	LOG("    %d vertices\n",obj[0]->get_n_vertices());
	LOG("    %d polygons\n",obj[0]->get_n_polys());
	Vision::unlock(false);
	if( !Vision::isLocked() ) {
		VisionObject *vo = dynamic_cast<VisionObject *>(obj[0]);
		vo->prepare();
	}

	if( !obj[0]->check() ) {
		Vision::setError(new VisionException(obj[0], VisionException::V_IMPORT_RWX_MDL_ERROR, "Imported RWX model is corrupt"));
	}
	return obj[0];
}

VI_VObject *Loader::importVObject(const char * filename) {
	const char *ext = strchr(filename,'.');
	if(ext!=NULL) {
		ext++;
		//if(_stricmp(ext,"3DS")==0)
		if(stricmp(ext,"3DS")==0)
			return import3DS(filename);
		/*else if(_stricmp(ext,"MDL")==0)
		return importMDL(filename);*/
		//else if(_stricmp(ext,"MD2")==0)
		else if(stricmp(ext,"MD2")==0)
			return importMD2(true,filename);
		//else if(_stricmp(ext,"RWX")==0)
		else if(stricmp(ext,"RWX")==0)
			return importRWX(filename);
	}
	Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Unknown filetype"));
	return NULL;
};

class NWNPoly {
public:
	int v[3];
	int t[3];

	NWNPoly() {
		for(int i=0;i<3;i++) {
			v[i] = 0;
			t[i] = 0;
		}
	}
};

/* Import 3D object in NeverWinter Nights MDL format.
*/
VI_SceneGraphNode *Loader::importNodeNWN(int *n_objs,VI_Object ***objs,const char *filename) {
	LOG("Importing NeverWinter Nights MDL File: %s\n",filename);
	Vision::lock();
	VI_SceneGraphNode *root = NULL;
	if( n_objs != NULL )
		*n_objs = 0;
	if( objs != NULL )
		*objs = NULL;
	//Vector *objs_v = new Vector();
	//vector<ObjectData *> *objs_v = new vector<ObjectData *>();
	vector<VI_Object *> *objs_v = new vector<VI_Object *>();

	VI_SceneGraphNode *c_node = NULL;
	//Object3D *c_obj = NULL;
	VI_Object *c_obj = NULL;
	NWNPoly *polys = NULL;
	int n_polys = 0;
	Vector3D *tverts = NULL;
	VI_Texture *c_texture = NULL;
	//char c_animname[NAMELEN+1] = "";
	string c_animname;
	AnimationInfo *c_animinfo = NULL;
	float c_length = 0.0;

	FILE *file = fopen(filename,"rb");
	if( file == NULL ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open NWN MDL file"));
		return NULL;
	}
	/*FILE *file = NULL;
	if( fopen_s(&file, filename, "rb") != 0 ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open NWN MDL file"));
		return NULL;
	}*/

	const int folder_size_c = 300;
	char folder[folder_size_c] = "";
	getFolder(folder, folder_size_c, filename);

	char buffer[1024];
	char *str = NULL;
	char *words[MAX_WORDS];
	bool ok = true;
	//int geom_count = 0;
	enum Mode {
		MODE_NONE = 0,
		MODE_GEOM = 1,
		MODE_ANIM = 2,
		MODE_POSITIONKEYLIST = 3,
		MODE_ROTATIONKEYLIST = 4
	};
	Mode mode = MODE_NONE;
	bool done_geom = false;
	float animationscale = 1.0;

	while(ok) {
		if(fgetLine(file,buffer))
			break;
		str = stripWhiteSpace(buffer);
		int n_words = getWords(str,words);
		if(n_words == 0)
			continue;
		if(*words[0]=='#') {
			// comment
		}
		/*else if(_stricmp(words[0],"setanimationscale")==0) {
		if( mode != MODE_NONE || n_words < 2 ) {
		LOG("ERROR - setanimationscale\n");
		ok = false;
		}
		animationscale = atof(words[1]);
		}*/
		//else if(_stricmp(words[0],"beginmodelgeom")==0) {
		else if(stricmp(words[0],"beginmodelgeom")==0) {
			/*if( geom_count != 0 ) {
			LOG("ERROR - beginmodelgeom\n");
			ok = false;
			}
			geom_count = 1;*/
			if( mode != MODE_NONE || done_geom ) {
				LOG("ERROR - beginmodelgeom\n");
				ok = false;
			}
			mode = MODE_GEOM;
		}
		//else if(_stricmp(words[0],"endmodelgeom")==0) {
		else if(stricmp(words[0],"endmodelgeom")==0) {
			/*if( geom_count != 1 ) {
			LOG("ERROR - endmodelgeom\n");
			ok = false;
			}
			geom_count = 2;*/
			if( mode != MODE_GEOM ) {
				LOG("ERROR - endmodelgeom\n");
				ok = false;
			}
			mode = MODE_NONE;
			done_geom = true;
		}
		//else if(_stricmp(words[0],"newanim")==0) {
		else if(stricmp(words[0],"newanim")==0) {
			if( mode != MODE_NONE || n_words < 3 ) {
				LOG("ERROR - newanim\n");
				ok = false;
			}
			mode = MODE_ANIM;
			/*strncpy(c_animname, words[1], NAMELEN);
			c_animname[NAMELEN] = '\0';*/
			c_animname = words[1];
		}
		//else if(_stricmp(words[0],"doneanim")==0) {
		else if(stricmp(words[0],"doneanim")==0) {
			if( mode != MODE_ANIM ) {
				LOG("ERROR - doneanim\n");
				ok = false;
			}
			mode = MODE_NONE;
			//*c_animname = '\0';
			c_animname.clear();
		}
		/*else if( geom_count != 1 ) {
		}*/
		else if( mode == MODE_NONE ) {
		}
		//else if(_stricmp(words[0],"endlist")==0) {
		else if(stricmp(words[0],"endlist")==0) {
			if( mode == MODE_POSITIONKEYLIST || mode == MODE_ROTATIONKEYLIST ) {
				mode = MODE_ANIM;
			}
			else {
				/*LOG("ERROR - endlist\n");
				ok = false;*/
			}
		}
		//else if(_stricmp(words[0],"positionkey")==0) {
		else if(stricmp(words[0],"positionkey")==0) {
			if( c_animinfo == NULL ) {
			}
			/*else if( mode != MODE_ANIM ) {
			LOG("ERROR - positionkey\n");
			ok = false;
			}*/
			else {
				mode = MODE_POSITIONKEYLIST;
			}
		}
		//else if(_stricmp(words[0],"orientationkey")==0) {
		else if(stricmp(words[0],"orientationkey")==0) {
			if( c_animinfo == NULL ) {
			}
			/*else if( mode != MODE_ANIM ) {
			LOG("ERROR - orientationkey\n");
			ok = false;
			}*/
			else {
				mode = MODE_ROTATIONKEYLIST;
			}
		}
		//else if(_stricmp(words[0],"node")==0) {
		else if(stricmp(words[0],"node")==0) {
			if( c_node != NULL || n_words < 3 ) {
				LOG("ERROR - node\n");
				ok = false;
			}
			else if( mode == MODE_GEOM ){
				/*if( _stricmp(words[1],"dummy") == 0
					|| _stricmp(words[1],"patch") == 0
					) {*/
				if( stricmp(words[1],"dummy") == 0
					|| stricmp(words[1],"patch") == 0
					) {
						// dummy node
						//c_node = new SceneGraphNode();
						c_node = new Entity();
						c_obj = NULL;
				}
				/*else if( _stricmp(words[1],"trimesh") == 0
					|| _stricmp(words[1],"danglymesh") == 0
					) {*/
				else if( stricmp(words[1],"trimesh") == 0
					|| stricmp(words[1],"danglymesh") == 0
					) {
						/*c_obj = new Object3D();
						c_node = new Entity(c_obj);*/
						c_obj = VI_VObject::create("words[1]");
						c_node = VI_createEntity(c_obj);
						//objs_v->add(c_obj);
						objs_v->push_back(c_obj);
				}
				//else if( _stricmp(words[1],"light") == 0 ) {
				else if( stricmp(words[1],"light") == 0 ) {
					c_node = new SceneGraphNode();
					c_obj = NULL;
					// not implemented!
				}
				//else if( _stricmp(words[1],"emitter") == 0 ) {
				else if( stricmp(words[1],"emitter") == 0 ) {
					//c_obj = new NWNParticleSystem(1000);
					c_obj = VI_GeneralParticlesystem::create(1000);
					c_node = new Entity(c_obj);
					//objs_v->add(c_obj);
					objs_v->push_back(c_obj);
				}
				else {
					LOG("ERROR - unknown node type\n");
					ok = false;
				}
				// init node
				if( ok ) {
					c_node->setName(words[2]);
					c_node->setSourcetype(V_SOURCETYPE_NWN);
				}
			}
			else if( mode == MODE_ANIM ) {
				c_node = root->findNode(words[2]);
				if( c_node == NULL ) {
					LOG("WARNING - can't find node\n");
					//ok = false;
				}
				/*else if( c_node->animationinfos == NULL ) {
					//c_node->animationinfos = new Vector();
					c_node->animationinfos = new vector<AnimationInfo *>();
				}*/
				else {
					SceneGraphNode *d_c_node = dynamic_cast<SceneGraphNode *>(c_node); // cast to the internal representation
					d_c_node->initAnimationInfos();
				}
				c_obj = NULL;
				if( c_node != NULL ) {
					c_animinfo = new AnimationInfo();
					c_animinfo->setName(c_animname.c_str());
					c_animinfo->end = c_animinfo->start + c_length;
				}
			}
		}
		//else if(_stricmp(words[0],"endnode")==0) {
		else if(stricmp(words[0],"endnode")==0) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_obj != NULL && d_c_obj->getClass() == V_CLASS_VOBJECT && (dynamic_cast<VI_VObject *>(d_c_obj))->get_n_vertices() > 0 ) {
				// need to set texture coordinates
				if( mode != MODE_GEOM || polys == NULL || ( c_texture != NULL && tverts == NULL ) ) {
					LOG("ERROR - polys or tverts not set\n");
					//LOG(">>> %s\n",c_node->getName());
					ok = false;
				}
				else {
					for(int i=0;i<n_polys;i++) {
						/*Polygon3D poly(polys[i].v[0], polys[i].v[1], polys[i].v[2]);
						if( c_texture != NULL ) {
							poly.setTexture(c_texture);
							for(int j=0;j<3;j++) {
								int indx = polys[i].t[j];
								poly.setTextureCoords(j, tverts[indx].x, tverts[indx].y);
								//poly.tx[j] = tverts[indx].x;
								//poly.ty[j] = tverts[indx].y;
							}
						}
						(static_cast<Object3D *>(c_obj))->addPolygon(poly);*/
						VI_Face *face = (dynamic_cast<VI_VObject *>(d_c_obj))->addPolygon(polys[i].v[0], polys[i].v[1], polys[i].v[2]);
						if( c_texture != NULL ) {
							float u[3], v[3];
							for(int j=0;j<3;j++) {
								int indx = polys[i].t[j];
								u[j] = tverts[indx].x;
								v[j] = tverts[indx].y;
							}
							(dynamic_cast<VI_VObject *>(d_c_obj))->setPolygonTextureCoords(face, c_texture, u, v);
						}
					}
					//(static_cast<Object3D *>(c_obj))->setShading(Polygon3D::CURVED, false);
				}
				if( polys != NULL ) {
					delete [] polys;
					polys = NULL;
				}
				if( tverts != NULL ) {
					delete [] tverts;
					tverts = NULL;
				}
				n_polys = 0;
			}
			//else if( mode == MODE_ANIM ) {
			else {
				if( mode != MODE_GEOM )
					mode = MODE_ANIM;
				if( c_animinfo == NULL ) {
					/*LOG("ERROR - animinfo not set\n");
					LOG(">>> %s\n",c_node->getName());
					ok = false;*/
				}
				/*else if( c_node->equals("rootdummy") ) { // ??? NWN hack
				}*/
				else {
					//LOG("%s : %d , %d\n", c_animinfo->getName(), c_animinfo->position_keys->size(), c_animinfo->rotation_keys->size());
					//c_node->animationinfos->add(c_animinfo);
					//c_node->animationinfos->push_back(c_animinfo);
					/*SceneGraphNode *d_c_node = dynamic_cast<SceneGraphNode *>(c_node); // cast to the internal representation
					d_c_node->addAnimationInfo(c_animinfo);*/
					c_node->addHAnimationInfo(c_animinfo);
				}
			}
			c_node = NULL;
			c_obj = NULL;
			c_texture = NULL;
			c_animinfo = NULL;
		}
		else if( mode == MODE_POSITIONKEYLIST ) {
			if( c_animinfo == NULL || n_words < 4 ) {
				LOG("ERROR - positionkeylist\n");
				ok = false;
			}
			/*else if( c_node->equals("rootdummy") ) { // ??? NWN hack
			}*/
			else {
				// should this be scaled by animationscale?
				float time = (float)atof(words[0]);
				Vector3D pos;
				pos.x = (float)atof(words[1]);
				pos.z = - (float)atof(words[2]);
				pos.y = (float)atof(words[3]);
				pos *= animationscale;
				c_animinfo->addPositionKey(time, pos);
			}
		}
		else if( mode == MODE_ROTATIONKEYLIST ) {
			if( c_animinfo == NULL || n_words < 5 ) {
				LOG("ERROR - rotationkeylist\n");
				ok = false;
			}
			else {
				float time = (float)atof(words[0]);
				float x = (float)atof(words[1]);
				float z = - (float)atof(words[2]);
				float y = (float)atof(words[3]);
				float a = (float)atof(words[4]);
				Rotation3D rot;
				rot.getQuaternion()->setAngleAxis(x, y, z, a);
				c_animinfo->addRotationKey(time, rot);
			}
		}
		//else if(_stricmp(words[0],"parent")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"parent")==0 && mode == MODE_GEOM) {
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - parent\n");
				ok = false;
			}
			else {
				//if( _stricmp(words[1],"NULL") == 0 ) {
				if( stricmp(words[1],"NULL") == 0 ) {
					if( root != NULL ) {
						LOG("ERROR - root already defined\n");
						ok = false;
					}
					else
						root = c_node;
				}
				else {
					VI_SceneGraphNode *parent = root->findNode(words[1]);
					if( parent == NULL ) {
						LOG("ERROR - can't find parent\n");
						ok = false;
					}
					else {
						parent->addNode(c_node);
					}
				}
			}
		}
		//else if(_stricmp(words[0],"position")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"position")==0 && mode == MODE_GEOM) {
			if( c_node == NULL || n_words < 4 ) {
				LOG("ERROR - position\n");
				ok = false;
			}
			/*else if( c_node->equals("rootdummy") ) { // bizarre NWN hack
			printf("!\n");
			float x = atof(words[1]);
			float z = - atof(words[2]);
			float y = -1000;
			//c_node->point.moveTo(x, y, z);
			Vector3D pos(x, y, z);
			c_node->setPosition(&pos);
			}*/
			else {
				float x = (float)atof(words[1]);
				float z = - (float)atof(words[2]);
				float y = (float)atof(words[3]);
				//c_node->point.moveTo(x, y, z);
				Vector3D pos(x, y, z);
				pos *= animationscale;
				/*if( c_node->equals("rootdummy") ) { // ??? NWN hack
				pos *= animationscale;
				}*/
				c_node->setPosition(&pos);
			}
		}
		//else if(_stricmp(words[0],"orientation")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"orientation")==0 && mode == MODE_GEOM) {
			if( c_node == NULL || n_words < 5 ) {
				LOG("ERROR - orientation\n");
				ok = false;
			}
			else {
				float x = (float)atof(words[1]);
				float z = - (float)atof(words[2]);
				float y = (float)atof(words[3]);
				float a = (float)atof(words[4]);
				//c_node->point.rot.getQuaternion()->setAngleAxis(x, y, z, a);
				//c_node->rotation()->getQuaternion()->setAngleAxis(x, y, z, a);
				Rotation3D rot;
				rot.getQuaternion()->setAngleAxis(x, y, z, a);
				SceneGraphNode *d_c_node = dynamic_cast<SceneGraphNode *>(c_node); // cast to the internal representation
				d_c_node->setRotation(&rot);
			}
		}
		//else if(_stricmp(words[0],"verts")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"verts")==0 && mode == MODE_GEOM) {
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - verts\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				// ??? not a trimesh etc
			}
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( d_c_obj->getClass() != V_CLASS_VOBJECT ) {
				LOG("ERROR - not a vobject\n");
				ok = false;
			}
			else {
				int n_verts = atoi(words[1]);
				for(int i=0;i<n_verts && ok;i++) {
					if(fgetLine(file,buffer)) {
						LOG("ERROR - not enough vertices\n");
						ok = false;
						break;
					}
					str = stripWhiteSpace(buffer);
					char *sub_words[MAX_WORDS];
					int n_sub_words = getWords(str,sub_words);
					if( n_sub_words != 3 ) {
						LOG("ERROR - vertex\n");
						ok = false;
					}
					else {
						Vector3D vert;
						vert.x = (float)atof(sub_words[0]);
						vert.z = - (float)atof(sub_words[1]);
						vert.y = (float)atof(sub_words[2]);
						vert *= animationscale;
						//(static_cast<Object3D *>(d_c_obj))->addVertex(0, vert);
						VI_VObject *vobj = dynamic_cast<VI_VObject *>(c_obj);
						vobj->addVertex(vert.x, vert.y, vert.z);
					}
					for(int i=0;i<n_sub_words;i++) {
						delete sub_words[i];
					}
				}
			}
		}
		//else if(_stricmp(words[0],"faces")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"faces")==0 && mode == MODE_GEOM) {
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - faces\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				// ??? not a trimesh etc
			}
			else {
				n_polys = atoi(words[1]);
				polys = new NWNPoly[n_polys];
				for(int i=0;i<n_polys && ok;i++) {
					if(fgetLine(file,buffer)) {
						LOG("ERROR - not enough faces\n");
						ok = false;
						break;
					}
					str = stripWhiteSpace(buffer);
					char *sub_words[MAX_WORDS];
					int n_sub_words = getWords(str,sub_words);
					if( n_sub_words != 8 ) {
						LOG("ERROR - face\n");
						ok = false;
					}
					else {
						/*int v1 = atof(sub_words[0]);
						int v2 = atof(sub_words[1]);
						int v3 = atof(sub_words[2]);
						Polygon3D poly(v1, v2, v3);
						c_obj->addPolygon(poly);*/
						for(int j=0;j<3;j++) {
							/*polys[i].v[j] = (float)atof(sub_words[j]);
							polys[i].t[j] = (float)atof(sub_words[4+j]);*/
							polys[i].v[j] = atoi(sub_words[j]);
							polys[i].t[j] = atoi(sub_words[4+j]);
						}
					}
					for(int i=0;i<n_sub_words;i++) {
						delete sub_words[i];
					}
				}
			}
		}
		//else if(_stricmp(words[0],"tverts")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"tverts")==0 && mode == MODE_GEOM) {
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - tverts\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				// ??? not a trimesh etc
			}
			else {
				int n_tverts = atoi(words[1]);
				tverts = new Vector3D[n_tverts];
				for(int i=0;i<n_tverts && ok;i++) {
					if(fgetLine(file,buffer)) {
						LOG("ERROR - not enough tverts\n");
						ok = false;
						break;
					}
					str = stripWhiteSpace(buffer);
					char *sub_words[MAX_WORDS];
					int n_sub_words = getWords(str,sub_words);
					if( n_sub_words != 3 ) {
						LOG("ERROR - tvert\n");
						ok = false;
					}
					else {
						tverts[i].x =(float) atof(sub_words[0]);
						tverts[i].y = (float)atof(sub_words[1]);
						//tverts[i].z = (float)atof(sub_words[2]); // should be zero
					}
					for(int i=0;i<n_sub_words;i++) {
						delete sub_words[i];
					}
				}
			}
		}
		//else if(_stricmp(words[0],"bitmap")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"bitmap")==0 && mode == MODE_GEOM) {
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - bitmap\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				// ??? not a trimesh etc
			}
			//else if( _stricmp(words[1],"NULL") == 0 ) {
			else if( stricmp(words[1],"NULL") == 0 ) {
				c_texture = NULL;
			}
			else {
				char filename_tx[1024] = "";
				sprintf(filename_tx,"%s%s.tga",folder,words[1]);
				//c_texture = Texture::loadTexture(filename_tx);
				try {
					c_texture = GraphicsEnvironment::getSingleton()->getRenderer()->loadTexture(filename_tx);
				}
				catch(VisionException *ve) {
					if( ve->type == VisionException::V_FILE_ERROR ) {
						if(c_texture == NULL) {
							LOG("WARNING - cannot load %s\n",filename_tx);
						}
						delete ve;
					}
					else {
						throw ve;
					}
				}
			}
		}
		//else if(_stricmp(words[0],"texture")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"texture")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - texture\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for texture\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			//else if( _stricmp(words[1],"NULL") == 0 ) {
			else if( stricmp(words[1],"NULL") == 0 ) {
				//(static_cast<NWNParticleSystem *>(d_c_obj))->texture = NULL;
				//(dynamic_cast<NWNParticleSystem *>(c_obj))->texture = NULL;
				(dynamic_cast<VI_Particlesystem *>(c_obj))->setTexture(NULL);
			}
			else {
				char filename_tx[1024] = "";
				sprintf(filename_tx,"%s%s.tga",folder,words[1]);
				//(static_cast<NWNParticleSystem *>(c_obj))->texture = Texture::loadTexture(filename_tx);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->texture = GraphicsEnvironment::getSingleton()->getRenderer()->loadTexture(filename_tx);
				//if((static_cast<NWNParticleSystem *>(d_c_obj))->texture == NULL) {
				VI_Texture *texture = NULL;
				try {
					texture = GraphicsEnvironment::getSingleton()->getRenderer()->loadTexture(filename_tx);
				}
				catch(VisionException *ve) {
					if( ve->type == VisionException::V_FILE_ERROR ) {
						if(c_texture == NULL) {
							LOG("WARNING - cannot load %s\n",filename_tx);
						}
						delete ve;
					}
					else {
						throw ve;
					}
				}
				if( texture != NULL ) {
					(dynamic_cast<VI_Particlesystem *>(c_obj))->setTexture(texture);
				}
			}
		}
		//else if(_stricmp(words[0],"colorstart")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"colorstart")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 4 ) {
				LOG("ERROR - colorstart\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for colorstart\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			else {
				float r = (float)atof(words[1]);
				float g = (float)atof(words[2]);
				float b = (float)atof(words[3]);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->color_st.setf(r,g,b);
				(dynamic_cast<VI_GeneralParticlesystem *>(c_obj))->setColoriStart((unsigned char)(255*r),(unsigned char)(255*g),(unsigned char)(255*b));
			}
		}
		//else if(_stricmp(words[0],"colorend")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"colorend")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 4 ) {
				LOG("ERROR - colorend\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for colorend\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			else {
				float r = (float)atof(words[1]);
				float g = (float)atof(words[2]);
				float b = (float)atof(words[3]);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->color_nd.setf(r,g,b);
				(dynamic_cast<VI_GeneralParticlesystem *>(c_obj))->setColoriEnd((unsigned char)(255*r),(unsigned char)(255*g),(unsigned char)(255*b));
			}
		}
		//else if(_stricmp(words[0],"sizestart")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"sizestart")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - sizestart\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for sizestart\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			else {
				float size = (float)atof(words[1]);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->size_st = size;
				(dynamic_cast<VI_GeneralParticlesystem *>(c_obj))->setSizeStart(size);
			}
		}
		//else if(_stricmp(words[0],"sizeend")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"sizeend")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - sizeend\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for sizeend\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			else {
				float size = (float)atof(words[1]);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->size_nd = size;
				(dynamic_cast<VI_GeneralParticlesystem *>(c_obj))->setSizeEnd(size);
			}
		}
		//else if(_stricmp(words[0],"mass")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"mass")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - mass\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for mass\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			else {
				float mass = (float)atof(words[1]);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->mass = mass;
				(dynamic_cast<VI_GeneralParticlesystem *>(c_obj))->setMass(mass);
			}
		}
		//else if(_stricmp(words[0],"birthrate")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"birthrate")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - birthrate\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for birthrate\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			else {
				float birthrate = (float)atoi(words[1]);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->birthRate = birthrate;
				(dynamic_cast<VI_GeneralParticlesystem *>(c_obj))->setBirthRate(birthrate);
			}
		}
		//else if(_stricmp(words[0],"velocity")==0 && mode == MODE_GEOM) {
		else if(stricmp(words[0],"velocity")==0 && mode == MODE_GEOM) {
			VisionObject *d_c_obj = dynamic_cast<VisionObject *>(c_obj); // cast to the internal representation
			if( c_node == NULL || n_words < 2 ) {
				LOG("ERROR - velocity\n");
				ok = false;
			}
			else if( c_obj == NULL ) {
				LOG("ERROR - no object defined for velocity\n");
			}
			else if( d_c_obj->getClass() != V_CLASS_NWNPARTICLESYSTEM ) {
				LOG("ERROR - not a particlesystem\n");
				ok = false;
			}
			else {
				float velocity = (float)atof(words[1]);
				//(static_cast<NWNParticleSystem *>(d_c_obj))->initVel = velocity;
				(dynamic_cast<VI_GeneralParticlesystem *>(c_obj))->setInitialVelocity(velocity);
			}
		}
		//else if(_stricmp(words[0],"length")==0) {
		else if(stricmp(words[0],"length")==0) {
			if( mode != MODE_ANIM || n_words < 2 ) {
				LOG("ERROR - length\n");
				ok = false;
			}
			else {
				c_length = (float)atof(words[1]);
			}
		}

		for(int i=0;i<n_words;i++) {
			delete words[i];
			words[i]=NULL;
		}
	}

	for(unsigned int i=0;i<objs_v->size() && ok;i++) {
		if( !objs_v->at(i)->check() ) {
			Vision::setError(new VisionException(objs_v->at(i), VisionException::V_IMPORT_NWN_MDL_ERROR, "Imported NWN model is corrupt"));
		}
	}
	Vision::unlock(false);
	if( ok ) {
		/*for(unsigned int i=0;i<objs_v->size();i++) {
			VI_VObject *vobj = dynamic_cast<VI_VObject *>(objs_v->at(i));
			vobj->setShading(VI_Face::FLAT);
			vobj->setTexture(NULL);
		}*/
		if( !Vision::isLocked() ) {
			for(unsigned int i=0;i<objs_v->size();i++) {
				VisionObject *vo = dynamic_cast<VisionObject *>(objs_v->at(i));
				vo->prepare();
			}
		}
		if( n_objs != NULL || objs != NULL ) {
			//objs_v->toArray(n_objs, (void ***)objs);
			if( n_objs != NULL )
				*n_objs = objs_v->size();
			if( objs != NULL ) {
				//*objs = new ObjectData *[objs_v->size()];
				*objs = new VI_Object *[objs_v->size()];
				for(unsigned int i=0;i<objs_v->size();i++) {
					(*objs)[i] = objs_v->at(i);
				}
			}
		}
	}
	else {
		delete root;
		root = NULL;
		Vision::setError(new VisionException(NULL,VisionException::V_IMPORT_NWN_MDL_ERROR,"Failed to import NWN MDL file"));
	}
	delete objs_v;

	return root;
}

VI_Mesh *Loader::importMD2(const char *filename, const char *skinfile) {
	LOG("Importing MD2 (Quake2) File: %s Skin: %s\n",filename,skinfile);
	Vision::lock();

	Texture *texture = NULL;
	if(skinfile != NULL) {
		//texture = Texture::loadTexture(skinfile);
		texture = GraphicsEnvironment::getSingleton()->getRenderer()->loadTexture(skinfile);
		if(texture == NULL) {
			Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open texture file"));
			return NULL;
		}
	}

	FILE *file = fopen(filename,"rb");
	if( file == NULL ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open file"));
		return NULL;
	}
	/*FILE *file = NULL;
	if( fopen_s(&file, filename, "rb") != 0 ) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Cannot open file"));
		return NULL;
	}*/

	fseek(file,0,SEEK_END);
	int filelen = ftell(file);
	fseek(file,0,SEEK_SET);
	char *buffer = new char [filelen + 1];
	fread(buffer,sizeof(char),filelen,file);
	fclose(file);
	file = NULL;

	md2_dmdl_t *header = (md2_dmdl_t *)buffer;
	ENDIANSWAPLONG(&header->ident);
	ENDIANSWAPLONG(&header->version);
	ENDIANSWAPLONG(&header->skinwidth);
	ENDIANSWAPLONG(&header->skinheight);
	ENDIANSWAPLONG(&header->framesize);
	ENDIANSWAPLONG(&header->num_skins);
	ENDIANSWAPLONG(&header->num_xyz);
	ENDIANSWAPLONG(&header->num_st);
	ENDIANSWAPLONG(&header->num_tris);
	ENDIANSWAPLONG(&header->num_glcmds);
	ENDIANSWAPLONG(&header->num_frames);
	ENDIANSWAPLONG(&header->ofs_skins);
	ENDIANSWAPLONG(&header->ofs_st);
	ENDIANSWAPLONG(&header->ofs_tris);
	ENDIANSWAPLONG(&header->ofs_frames);
	ENDIANSWAPLONG(&header->ofs_glcmds);
	ENDIANSWAPLONG(&header->ofs_end);
	LOG("MD2Object ID %d version %d\n",header->ident,header->version);
	if(header->ident != 844121161) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Not a valid MD2 file"));
		return NULL;
	}
	if(header->version != 8) {
		Vision::setError(new VisionException(NULL,VisionException::V_FILE_ERROR,"Only version 8 MD2 files are supported"));
		return NULL;
	}

	LOG("    %d frames\n",header->num_frames);
	LOG("    %d vertices\n",header->num_xyz);
	LOG("    %d polygons\n",header->num_tris);

	/*Mesh *mesh = new Mesh();
	mesh->n_frames = header->num_frames;*/
	//Mesh *mesh = new Mesh(header->num_frames);
	VI_Mesh *mesh = VI_Mesh::create("Imported from Loader::importMD2", header->num_frames);

	mesh->setAnimFrames(V_ANIMSTATE_MD2_IDLE, 0, 39);
	mesh->setAnimFrames(V_ANIMSTATE_MD2_CROUCH, 136, 154);
	mesh->setAnimFrames(V_ANIMSTATE_MD2_RUN, 40, 45);
	mesh->setAnimFrames(V_ANIMSTATE_MD2_JUMP, 67, 73);
	mesh->setAnimFrames(V_ANIMSTATE_MD2_FIRE, 47, 53);
	mesh->setAnimFrames(V_ANIMSTATE_MD2_DIE, 170, 177);
	mesh->setAnimFrames(V_ANIMSTATE_MD2_ALL, 0, -1);

	mesh->addTexture(texture);

	Vertex3D *pointList = new Vertex3D[header->num_xyz * mesh->getNFrames()];

	for(int j=0;j<mesh->getNFrames();j++) {
		md2_frame_t *frame = (md2_frame_t *)&buffer[header->ofs_frames + header->framesize * j ];
		ENDIANSWAPLONG(&frame->scale[0]);
		ENDIANSWAPLONG(&frame->scale[1]);
		ENDIANSWAPLONG(&frame->scale[2]);
		ENDIANSWAPLONG(&frame->translate[0]);
		ENDIANSWAPLONG(&frame->translate[1]);
		ENDIANSWAPLONG(&frame->translate[2]);
		//LOG("frame %d : scale %f , %f , %f : translate %f , %f , %f\n", j, frame->scale[0], frame->scale[1], frame->scale[2], frame->translate[0], frame->translate[1], frame->translate[2]);
		Vertex3D *pL = &pointList[header->num_xyz * j];
		for(int i=0;i<header->num_xyz;i++) {
			pL[i].z = - ( frame->scale[0] * frame->fp[i].v[0] + frame->translate[0] );
			pL[i].x =   ( frame->scale[1] * frame->fp[i].v[1] + frame->translate[1] );
			pL[i].y =   ( frame->scale[2] * frame->fp[i].v[2] + frame->translate[2] );
			/*if( j == 0 ) {
			LOG("%d : %f , %f , %f\n", i, pL[i].x, pL[i].y, pL[i].z);
			}*/
		}
	}

	int n_st = 0;
	md2_texCoord_t *st = NULL;
	if( texture != NULL ) {
		n_st = header->num_st;
		st = new md2_texCoord_t[n_st];

		md2_stIndex_t *stPtr = (md2_stIndex_t *)&buffer[header->ofs_st];
		for(int i=0;i<n_st;i++) {
			ENDIANSWAPSHORT(&stPtr[i].s);
			ENDIANSWAPSHORT(&stPtr[i].t);
			// textures may be rescaled (to power of 2), so we need to use the original width/heights!
			/*st[i].s = (float)stPtr[i].s / (float)texture->getWidth();
			st[i].t = 1.0f - (float)stPtr[i].t / (float)texture->getHeight();*/
			st[i].s = (float)stPtr[i].s / (float)header->skinwidth;
			st[i].t = 1.0f - (float)stPtr[i].t / (float)header->skinheight;
		}
	}

	md2_mesh_t *triIndex = new md2_mesh_t[header->num_tris];

	md2_mesh_t *bufIndexPtr = (md2_mesh_t *)&buffer[header->ofs_tris];
	for(int j=0;j<mesh->getNFrames();j++) {
		for(int i=0;i<header->num_tris;i++) {
			ENDIANSWAPSHORT(&bufIndexPtr[i].index_xyz[0]);
			ENDIANSWAPSHORT(&bufIndexPtr[i].index_xyz[1]);
			ENDIANSWAPSHORT(&bufIndexPtr[i].index_xyz[2]);
			ENDIANSWAPSHORT(&bufIndexPtr[i].index_st[0]);
			ENDIANSWAPSHORT(&bufIndexPtr[i].index_st[1]);
			ENDIANSWAPSHORT(&bufIndexPtr[i].index_st[2]);
			triIndex[i].index_xyz[0] = bufIndexPtr[i].index_xyz[0];
			triIndex[i].index_xyz[1] = bufIndexPtr[i].index_xyz[1];
			triIndex[i].index_xyz[2] = bufIndexPtr[i].index_xyz[2];
			triIndex[i].index_st[0] = bufIndexPtr[i].index_st[0];
			triIndex[i].index_st[1] = bufIndexPtr[i].index_st[1];
			triIndex[i].index_st[2] = bufIndexPtr[i].index_st[2];
		}
	}

	// calculate vertex normals
	//Vector *vx_polys = new Vector[header->num_xyz];
	vector<int> *vx_polys = new vector<int>[header->num_xyz];
	for(int j=0;j<header->num_tris;j++) {
		for(int k=0;k<3;k++) {
			int vx_indx = triIndex[j].index_xyz[k];
			//vx_polys[vx_indx].add((void *)j);
			vx_polys[vx_indx].push_back(j);
		}
	}

	Vector3D *poly_normals = new Vector3D[header->num_tris];
	for(int frame = 0;frame<mesh->getNFrames();frame++) {
		Vertex3D *pL = &pointList[header->num_xyz * frame];
		int i;
		for(i=0;i<header->num_tris;i++) {
			Vector3D *p0 = &pL[ triIndex[i].index_xyz[0] ];
			Vector3D *p1 = &pL[ triIndex[i].index_xyz[1] ];
			Vector3D *p2 = &pL[ triIndex[i].index_xyz[2] ];

			poly_normals[i] = *p2 - *p0;
			Vector3D v = *p1 - *p0;
			poly_normals[i].cross(&v);
			if(poly_normals[i].square() > V_TOL_MACHINE)
				poly_normals[i].normalise();
			else
				poly_normals[i].set(0.0,0.0,0.0);
		}
		for(i=0;i<header->num_xyz;i++) {
			pL[i].normal.set(0.0,0.0,0.0);
			//for(int j=0;j<header->num_tris;j++) {
			//	if( i == triIndex[j].index_xyz[0] ||
			//                i == triIndex[j].index_xyz[1] ||
			//        	i == triIndex[j].index_xyz[2] ) {
			//                pL[i].normal += poly_normals[j];
			//        }
			//}
			for(unsigned int j=0;j<vx_polys[i].size();j++) {
				//int poly_indx = (int)vx_polys[i].get(j);
				int poly_indx = vx_polys[i].at(j);
				pL[i].normal += poly_normals[poly_indx];
			}
			if(pL[i].normal.square() > V_TOL_MACHINE)
				pL[i].normal.normalise();
		}
	}
	delete [] vx_polys;
	delete [] poly_normals;

	int max_points = 3 * header->num_tris;
	/*mesh->n_renderDatas = 1;
	mesh->renderDatas = new RenderData[ mesh->n_renderDatas ];*/
	RenderData *rd = new RenderData();
	/*mesh->renderDatas.resize( 1 );
	mesh->renderDatas[0] = rd;*/
	Mesh *d_mesh = dynamic_cast<Mesh *>(mesh); // cast to the internal representation
	d_mesh->addRenderData(rd);
	rd->initVertexArrays(mesh->getNFrames(), max_points, false, false, true, true);
	rd->texture = texture;
	rd->solid = true;
	rd->cols[0] = 255;
	rd->cols[1] = 255;
	rd->cols[2] = 255;
	rd->cols[3] = 255;

	unsigned short *vx_index = new unsigned short[max_points]; // this maps vertices in the RenderData to vertices in the MD2 object, since some vertices may have different texture coords!
	unsigned short *st_index = new unsigned short[max_points];
	rd->va_indices = new unsigned short[max_points];
	int indx = 0;
	for(int i=0,count=0;i<header->num_tris;i++) {
		for(int j=0;j<3;j++) {
			int this_vx_index = triIndex[i].index_xyz[j];
			int this_st_index = triIndex[i].index_st[j];
			int found_indx = -1;
			for(int k=0;k<indx && found_indx == -1;k++) {
				if( vx_index[k] == this_vx_index && st_index[k] == this_st_index ) {
					//if( vx_index[k] == this_vx_index ) {
					found_indx = k;
				}
			}
			if( found_indx != -1 ) {
				rd->va_indices[count++] = found_indx;
			}
			else {
				vx_index[indx] = this_vx_index;
				st_index[indx] = this_st_index;
				rd->va_indices[count++] = indx++;
			}
		}
	}
	/*int indx = header->num_xyz;
	for(int i=0;i<header->num_xyz;i++) {
	vx_index[i] = i;
	}
	for(int i=0,count=0;i<header->num_tris;i++) {
	for(int j=0;j<3;j++) {
	rd.va_indices[count++] = triIndex[i].index_xyz[j];
	}
	}*/
	rd->n_vertices = indx;
	rd->n_renderlength = header->num_tris*3;

	for(int frame=0,count = 0;frame<mesh->getNFrames();frame++) {
		Vertex3D *pL = &pointList[header->num_xyz * frame];
		for(unsigned int i=0;i<rd->n_vertices;i++) {
			Vertex3D *vx = &pL[ vx_index[i] ];
			rd->va_vertices[count] = vx->x;
			rd->va_normals[count++] = vx->normal.x;
			rd->va_vertices[count] = vx->y;
			rd->va_normals[count++] = vx->normal.y;
			rd->va_vertices[count] = vx->z;
			rd->va_normals[count++] = vx->normal.z;
		}
	}

	for(unsigned int i=0;i<rd->n_vertices;i++) {
		md2_texCoord_t *this_st = &st[ st_index[i] ];
		//md2_texCoord_t *this_st = &st[ 0 ];
		rd->va_texcoords[2*i] = this_st->s;
		rd->va_texcoords[2*i+1] = this_st->t;
	}

	delete [] vx_index;
	vx_index = NULL;
	delete [] st_index;
	st_index = NULL;

	/*for(int i=0;i<mesh->n_renderDatas;i++)
	mesh->renderDatas[i].prepare();*/

	delete [] pointList;
	if( st != NULL )
		delete [] st;
	delete [] triIndex;

	Vision::unlock(false);
	if( !Vision::isLocked() ) {
		VisionObject *vo = dynamic_cast<VisionObject *>(mesh);
		vo->prepare();
	}
	LOG("    done\n");

	return mesh;
}
