#pragma once

#include "VisionIface.h"

const int max_sounds_c = 1024;

class Sound : public VI_Sound {
protected:
	bool initialised;
public:

	Sound();
	virtual ~Sound() {}

	bool isInitialised() const {
		return this->initialised;
	}
};

//#ifdef V_USE_SDL

#ifdef _WIN32
#include <SDL_mixer.h>
#elif __linux
#include <SDL/SDL_mixer.h>
#endif

class SDL_Sound : public Sound {
	Mix_Chunk *chunks[max_sounds_c];
	int channels[max_sounds_c];
public:
	SDL_Sound();
	virtual ~SDL_Sound();

	// interface
	virtual bool LoadSound(int s,const char *file);
	virtual bool PlaySound(int s,bool loop,int delay);
	virtual void FreeSound(int s);
	virtual bool IsSoundPlaying(int s);
	virtual void StopSound(int s,bool bResetPosition);

	virtual void playMedia(const char *filename);
	virtual bool isMediaPlaying();

#ifdef _WIN32
	virtual void processEvents(UINT message, WPARAM wParam, LPARAM lParam) {
	}
	virtual bool initHWND(HWND hWnd) {
		return false;
	}
#endif
};

//#endif
