#pragma once

#include <vector>
using std::vector;

#include "../Vision/VisionIface.h"

const int infowindow_def_x_c = 128;
const int infowindow_def_y_c = 64;
//const int infowindow_def_w_c = 480;
//const int infowindow_def_h_c = 140;
const int infowindow_def_w_c = 440;
//const int infowindow_def_h_c = 440;
//const int infowindow_def_h_c = 400;
const int infowindow_def_h_c = 256;

class InfoWindow {
	VI_GraphicsEnvironment *genv;
	VI_Panel *panel;
	/*VI_Button **buttons;
	int n_buttons;*/
	vector<VI_Button *> buttons;
	VI_Textfield *textfield;
	//static InfoWindow *activeWindow;
	bool is_modal;
	bool close;
	int close_value;

	static void paintPanel(VI_Graphics2D *g2d, void *data);
	static void action(VI_Panel *source);

	void init(VI_GraphicsEnvironment *genv, VI_Panel *parent, string text, VI_Font *font, VI_Texture *panel_texture, const string *button_texts, int n_buttons, int x, int y, int w, int h);
public:
	InfoWindow(VI_GraphicsEnvironment *genv, VI_Panel *parent, string text, VI_Font *font, VI_Texture *panel_texture, const string *button_texts, int n_buttons, int x, int y, int w, int h);
	InfoWindow(VI_GraphicsEnvironment *genv, VI_Panel *parent, string text, VI_Font *font, VI_Texture *panel_texture, int x, int y, int w, int h);
	InfoWindow(VI_GraphicsEnvironment *genv, VI_Panel *parent, string text, VI_Font *font, VI_Texture *panel_texture);
	~InfoWindow();

	const VI_Panel *getPanel() const {
		return panel;
	}
	VI_Panel *getPanel() {
		return panel;
	}
	const VI_Button *getButton(int index) const;
	VI_Button *getButton(int index);
	/*static InfoWindow *getActiveWindow() {
		return activeWindow;
	}
	static void clearActiveWindow() {
		activeWindow = NULL;
	}*/

	int doModal();

	static bool confirm(VI_GraphicsEnvironment *genv, VI_Panel *parent, VI_Font *font, VI_Texture *panel_texture, string text, string yes, string no);
	static int select(VI_GraphicsEnvironment *genv, VI_Panel *parent, VI_Font *font, VI_Texture *panel_texture, string text, string yes, string no, int window_h, const vector<string> *list);
};
