#include "utils.h"

#include "../Vision/VisionIface.h"

#include <cstring>

/*int Pos2D::distanceChebyshev(const Pos2D *p) const {
	int dx = abs(x - p->x);
	int dy = abs(y - p->y);
	return max(dx, dy);
}*/

Rational::Rational() : num(1), den(1) {
}

Rational::Rational(int num) : num(num), den(1) {
}

Rational::Rational(int num, int den) : num(num), den(den) {
	ASSERT( den > 0 );
}

void parseFileLine(char *word, const char *line, const char *pref) {
	//VI_log("parseFileLine: %s\n", line);
	//VI_log("    pref: %s\n", pref);
	int offset = strlen(pref);
	char *dest = word;
	const char *src = &line[offset];
	while( *src != '\0' && *src != '\r' && *src != '\n' )
		*dest++ = *src++;
	*dest++ = '\0';
	//VI_log("    return: %s\n", word);
}

bool parseBool(bool *ok, const char *word) {
	*ok = true;
	if( strcmp(word, "0") == 0 ) {
		return false;
	}
	else if( strcmp(word, "1") == 0 ) {
		return true;
	}
	*ok = false;
	return false;
}

bool matchFileLine(const char *line, const char *pref) {
	if( strnicmp(line, pref, strlen(pref)) == 0 ) {
		return true;
	}
	else {
		return false;
	}
}

void getDir(int *dx, int *dy, int c) {
	switch( c ) {
		case 0:
			*dx = 0;
			*dy = -1;
			break;
		case 1:
			*dx = 1;
			*dy = -1;
			break;
		case 2:
			*dx = 1;
			*dy = 0;
			break;
		case 3:
			*dx = 1;
			*dy = 1;
			break;
		case 4:
			*dx = 0;
			*dy = 1;
			break;
		case 5:
			*dx = -1;
			*dy = 1;
			break;
		case 6:
			*dx = -1;
			*dy = 0;
			break;
		case 7:
			*dx = -1;
			*dy = -1;
			break;
		default:
			ASSERT(false);
	}
}
